
#ifndef __XASTIR_ALERT_H
#define __XASTIR_ALERT_H

#include <time.h>
#include "db.h"
#include "maps.h"

typedef struct
{
    unsigned long top_boundary, left_boundary, bottom_boundary, right_boundary;
    time_t expiration;
    char activity[21];
    char alert_tag[21];
    char title[33];
    char alert_level;
    char from[10];
    char to[10];
    /* referenced flags 
       0 - on screen
    */
    char flags[16];
    char filename[64];
} alert_entry;

extern alert_entry *alert_list;
extern int alert_list_count;
extern char *alert_tag;
void alert_print_list(void);
extern void alert_update_list(alert_entry * alert, int match_level);
extern void alert_sort_active(void);
extern int alert_active(alert_entry *alert, int match_level);
extern int alert_display_request(void);
extern int alert_on_screen(void);
extern int alert_message_scan(void);
extern int alert_redraw_on_new_data;

/* from util.c */
extern time_t time_from_aprsstring(char *);

#endif /* __XASTIR_ALERT_H */
