/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea, KC0DGE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MessageB.h>
#include <Xm/DrawingA.h>
#include <Xm/RowColumn.h>
#include <Xm/TextF.h>
#include <Xm/MenuShell.h>
#include <Xm/BulletinB.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/PanedW.h>
#include <Xm/Form.h>
#include <Xm/CascadeBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/Separator.h>
#include <Xm/MainW.h>
#include <Xm/Text.h>
#include <Xm/List.h>
#include <Xm/XmStrDefs.h>
#include <Xm/ScrolledW.h>
#include <Xm/LabelG.h>
#include <Xm/Label.h>
#include <Xm/Protocols.h>
#include <Xm/ToggleBG.h>
#include <Xm/FileSB.h>
#include <Xm/MwmUtil.h>

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#include <math.h>

#include "xastir.h"
#include "symbols.h"
#include "alert.h"


extern Widget da;
extern Widget station_popup;
Widget station_list;

Widget si_text;
extern SymbolData symbol_data[];
Widget station_info = (Widget)NULL;
extern int debug_level;

extern void busy_cursor(Widget w);
extern int symbol_alt_display;         
extern int symbol_course_display;      
extern int symbol_speed_display;       
extern int symbol_dist_course_display; 
extern int colors[256];
extern int max_trail_colors;
extern int trail_colors[32];
extern int current_trail_color;  
extern int station_trails;
extern int search_fcc_data_appl(char *callsign, FccAppl *data);
extern int search_rac_data(char *callsign, rac_record *data);
extern void check_fcc_data(void); 
extern void check_rac_data(void);

/* station cleared after */
extern time_t sec_clear;
extern time_t sec_old;

extern int show_phg;
extern void draw_phg(long x_long, long y_lat, char *phg, time_t sec_heard, Pixmap where);
extern int read_file;
extern Widget GetTopShell(Widget w);
extern void pos_dialog(Widget w);
extern void draw_symbol(Widget w, char symbol_table, char symbol_id, char sybmol_overlay, long x_long, long y_lat, char *callsign_text, char *alt_text, char *course_text, char *speed_text, char *my_distance, char *my_course, char *wx_temp, char* wx_wind, time_t sec_heard, Pixmap where);
extern int redraw_on_new_data;

void redraw_symbols(Widget w);
extern long convert_lat_string(char *lat);
extern long convert_long_string(char *lng);
extern char *convert_long_lat_string(long lat, char *str);
extern char *convert_long_long_string(long lon, char *str);

extern int units_english_metric;
extern Pixmap pixmap_final;

extern int operate_as_an_igate;

/* from igate.c */
extern void output_igate_net(char *line, int port);
extern void output_igate_rf(char *from, char *call, char *path, char *line, int port);

/* from sound.c */
extern pid_t play_sound(char *sound_cmd, char *soundfile);

/* from fcc_data.c */
extern int fcc_data_available;

/* from rac_data.c */
extern int rac_data_available; 

/* from wx.c */
extern void wx_fill_data(int from, int type, char *data, DataRow *fill);

/* from symbol.c */
extern void symbol(Widget w, int ghost,char symbol_table, char symbol_id, char symbol_overlay, Pixmap where, int mask, long x_offset, long y_offset);
extern Widget appshell;


/* GLOBAL DEFINES */
extern GC gc;
extern Pixmap  pixmap;
extern Pixmap  pixmap_final;

extern double distance_between_string(char *lat_point1, char *long_point1, char *lat_point2, char *long_point2, char *course_deg);
extern Widget text;
extern Widget text3;
extern int wait_to_redraw;
extern int my_last_course;
extern int my_last_speed;
extern long my_last_altitude;  
extern long x_long_offset;
extern long screen_width;
extern long size;
extern long y_lat_offset;
extern long screen_height;
extern void create_image(Widget w);
extern long mid_x_long_offset;
extern long mid_y_lat_offset; 
extern int menu_x;
extern int menu_y;
extern time_t sec_now(void);

long POINTER_SIZE = sizeof(long);
long RECORD_SIZE = sizeof(DataRow);

long MPOINTER_SIZE = sizeof(long);
long MRECORD_SIZE = sizeof(Message);

int new_message_data;

/* from main.c */
extern char DATABASE_FILE[];
extern char DATABASE_POINTER_FILE[];
extern char DATABASE_POINTER_TEMP[];

extern char MDATABASE_FILE[];
extern char MDATABASE_POINTER_FILE[];
extern char MDATABASE_POINTER_TEMP[];

extern char sound_command[];
extern int sound_play_new_station;
extern char sound_new_station[];
extern int sound_play_new_message;
extern char sound_new_message[];


extern int sound_play_prox_message;
extern char sound_prox_message[];
extern char prox_min[30];
extern char prox_max[30];

extern int sound_play_band_open_message;
extern char sound_band_open_message[];
extern char bando_min[30];
extern char bando_max[30];

extern Widget Display_data_dialog;
extern Widget Display_data_text;                   

extern Message_Window mw[MAX_MESSAGE_WINDOWS+1];
extern void Send_message(Widget w, XtPointer clientData, XtPointer callData);
extern void Send_message_call(Widget w, XtPointer clientData, XtPointer callData);
extern int Display_packet_data_type;
extern char tracking_station_call[];
extern Widget track_case_data, track_match_data;
extern int track_station_on;
extern int track_case;
extern int track_match;
extern Pixel GetPixelByName(Widget w, char *colorname);

/* from lang.c */
extern int load_language_file(char *filename);
extern char *langcode(char *code);
extern char langcode_hotkey(char *code);

/* from messages.c */
extern int auto_reply;
extern char auto_reply_message[100];
extern void clear_acked_message(char *from, char *to, char *seq);
extern void transmit_message_data(char *to, char *message);
extern void output_message(char *from, char *to, char *message);
extern int check_popup_window(char *from_call_sign);
extern int look_for_open_group_data(char *to);

void track_station(Widget w, char *call, char *call_now, long now_long, long now_lat);

char packet_data[16][300];
int packet_data_display;
int redraw_on_new_packet_data;


DataRow station_data[MAX_STATIONS+1];
int station_ptr[MAX_STATIONS+1];
int stations;


char *get_time(char *time_here)
{
struct tm *time_now;

time_t timenw;

time(&timenw);
time_now = localtime(&timenw);
strftime(time_here,MAX_TIME,"%m%d%Y%H%M%S",time_now);
return(time_here);
}

char *to_upper(char *data)
{int i;

for(i=strlen(data)-1;i>=0;i--)
   {if(isalpha(data[i]))
      {data[i]=toupper(data[i]);}
   }
return(data);
}

int is_num_stuff(char *data, int max)
{int i;
 int ok;

ok=1;
for(i=0; i<max;i++)
  {if(!(isdigit(data[i]) || data[i]=='-' || data[i]=='+' || data[i]=='.'))
     {ok=0;break;}
  }
return(ok);
}

int is_num(char *data)
{int i;
 int ok;

ok=1;
for(i=strlen(data)-1;i>=0;i--)
  {if(!isdigit(data[i]))
     {ok=0;break;}
  }
return(ok);
}

int is_xnum_or_dash(char *data, int max)
{int i;
 int ok;

ok=1;
for(i=0; i<max;i++)
  {if(!(isxdigit(data[i]) || data[i]=='-'))
     {ok=0;break;}
  }
return(ok);
}

int is_call(char *data)
{int i;
 int ok;

ok=1;
for(i=strlen(data)-1;i>=0;i--)
  {if(!(isprint(data[i]) || data[i]=='-'))
     {ok=0;break;}
  }
if(!ok)
  {printf("Error on Callsign <%s>\n",data);}
return(ok);
}

char *remove_trailing_spaces(char *data)
{int i;

for(i=strlen(data)-1;i>=0;i--)
   {if(data[i]==' ')
      {data[i]=0;}
      else
      {break;}
   }
return(data);
}

char *remove_trailing_asterisk(char *data)
{int i;

for(i=strlen(data)-1;i>0;i--)
   {if(data[i]=='*')
      {data[i]=0;}
      else
      {break;}
   }
return(data);
}

/***** message data ****/

#ifdef MSG_DEBUG
void mclear_data(Message *clear)
{int size;
 int i;
 unsigned char *data_ptr;

 data_ptr = (unsigned char *)clear;
 size=sizeof(Message);
 for(i=0;i<size;i++)
    {*data_ptr++ = 0;}
}

void mcopy_data(Message *to, Message *from)
{int size;
 int i;
 unsigned char *data_ptr;
 unsigned char *data_ptr_from;

 data_ptr = (unsigned char *)to;
 data_ptr_from = (unsigned char *)from;
 size=sizeof(Message);
 for(i=0;i<size;i++)
    {*data_ptr++ = *data_ptr_from++;}
}
#endif /* MSG_DEBUG */

void mreset_pointers(FILE *pointer,long new_data_ptr,long records, int type, long start_ptr)
{long cp;
 long temp[13000];
 long buffn,start_buffn;
 long cp_records; 
 long max_buffer;

max_buffer=13000l;
if(type==0)
  {/* before start_ptr */
   /* copy back pointers */
   cp=start_ptr;
   for(buffn=records; buffn > start_ptr; buffn-=max_buffer)
      {start_buffn=buffn-max_buffer;
       if(start_buffn<start_ptr)
         {start_buffn=start_ptr;}
       cp_records=buffn-start_buffn;
       fseek(pointer,(MPOINTER_SIZE*start_buffn),SEEK_SET);
       if(fread(&temp,(MPOINTER_SIZE*cp_records),1,pointer)==1)
         {fseek(pointer,(MPOINTER_SIZE*(start_buffn+1)),SEEK_SET);
          fwrite(&temp,(MPOINTER_SIZE*cp_records),1,pointer);
	 }
      }    
   /* copy new pointer in */
   fseek(pointer,(MPOINTER_SIZE*start_ptr),SEEK_SET);
   fwrite(&new_data_ptr,MPOINTER_SIZE,1,pointer);
  }
}

long minput_database(Message fill)
{FILE *data;
 FILE *pointer;
 Message file_data;

 char tempfile[MAX_CALLSIGN+MAX_CALLSIGN+MAX_MESSAGE_ORDER+1];
 char tempfill[MAX_CALLSIGN+MAX_CALLSIGN+MAX_MESSAGE_ORDER+1];

long data_ptr;
long new_data_ptr;
long return_records;
long records;
long record_start;
long record_end;
long record_mid;
int done;

sprintf(tempfill,"%s%s%s",fill.call_sign,fill.from_call_sign,fill.seq);
fill.active=RECORD_ACTIVE;
data_ptr=0l;
data=NULL;
return_records=0l;
pointer = fopen(MDATABASE_POINTER_FILE,"r+");
/* check if file is there */
if(pointer == NULL)
  {pointer = fopen(MDATABASE_POINTER_FILE,"a+");}

if(pointer!=NULL)
  {data = fopen(MDATABASE_FILE,"a+");
   if(data!=NULL)
     {new_data_ptr = data_ptr = ftell(data);
      fwrite(&fill,MRECORD_SIZE,1,data);
      records = (data_ptr/sizeof(fill));
      return_records=records+1;
      if(records<1)
        {/* no data yet */
         fseek(pointer,0l,SEEK_SET);
         fwrite(&data_ptr,MPOINTER_SIZE,1,pointer);
	}
        else
        {/* more than one record*/
         fseek(pointer,(MPOINTER_SIZE*records),SEEK_SET);
         fwrite(&data_ptr,MPOINTER_SIZE,1,pointer);
         record_start=0l;
         record_end=records;
         record_mid=(record_end-record_start)/2; 

         done=0;
         while(!done)
              {/*printf("Records Start %ld, Mid %ld, End %ld\n",record_start,record_mid,record_end);*/
               /* get data for record start */
               fseek(pointer,(MPOINTER_SIZE*record_start),SEEK_SET);
               fread(&data_ptr,MPOINTER_SIZE,1,pointer);
               fseek(data,data_ptr,SEEK_SET);
               if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                 {/* COMPARE HERE */
                  sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                  if(strcmp(tempfill,tempfile)<0) 
                    {/* file name comes before */
                     /*printf("END - Before start\n");*/
                     done=1;
                     /* now place pointer before start*/
                     mreset_pointers(pointer,new_data_ptr,records,0,record_start); 
		    }
                    else
                    {/* get data for record end */  
                     fseek(pointer,(MPOINTER_SIZE*record_end),SEEK_SET);
                     fread(&data_ptr,MPOINTER_SIZE,1,pointer);
                     fseek(data,data_ptr,SEEK_SET);
                     if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                       {/* COMPARE HERE */
                        sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                        if(strcmp(tempfill,tempfile)>0)
                          {/* file name comes after */
                           /*printf("END - After end\n");*/
                           done=1;
                           /* now place pointer after end */

			  }
                          else
                          {if((record_mid==record_start) || (record_mid==record_end))
                             {/* no mid for compare check to see if in the middle */
                              /*printf("END - NO Middle\n");*/ 
                              done=1;
                              /* now place pointer before start*/
                              if(record_mid==record_start)
                                {mreset_pointers(pointer,new_data_ptr,records,0,record_mid+1);}
                                else 
                                {mreset_pointers(pointer,new_data_ptr,records,0,record_mid-1);}
			     }
                             else
                             {/* get data for record mid */
                              fseek(pointer,(MPOINTER_SIZE*record_mid),SEEK_SET);
                              fread(&data_ptr,MPOINTER_SIZE,1,pointer);
                              fseek(data,data_ptr,SEEK_SET);
                              if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                                {/* COMPARE HERE */
                                 sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                                 if(strcmp(tempfill,tempfile)<0)
                                   {/* checking  comes before */
                                    /*record_start=0l;*/
                                    record_end=record_mid;
                                    record_mid=record_start+(record_end-record_start)/2; 
                                    /*printf("TOP %ld, mid %ld\n",record_mid,record_end);*/     
				   }
                                   else
                                   {/* ckecking come after*/
                                    record_start=record_mid;
                                    /*record_end=end*/
                                    record_mid=record_start+(record_end-record_start)/2;
                                    /*printf("BOTTOM start %ld, mid %ld\n",record_start,record_mid);*/     
				   }
				}

			     }

			  }

		       }
		    }

		 }
	      }
	}
     }
     else
     {printf("Could not open file %s\n",MDATABASE_FILE);}
  }
  else
  {printf("Could not open file %s\n",MDATABASE_POINTER_FILE);}
if(data!=NULL)
  {fclose(data);}
if(pointer!=NULL)
  {fclose(pointer);}
return(return_records);
}


long mfind_data(Message fill)
{FILE *data;
 FILE *pointer;
 Message file_data;

 char tempfile[MAX_CALLSIGN+MAX_CALLSIGN+MAX_MESSAGE_ORDER+1];
 char tempfill[MAX_CALLSIGN+MAX_CALLSIGN+MAX_MESSAGE_ORDER+1];

long data_ptr;
long new_data_ptr;
long return_record;
long records;
long record_start;
long record_end;
long record_mid;
int done;


sprintf(tempfill,"%s%s%s",fill.call_sign,fill.from_call_sign,fill.seq);
data_ptr=0l;
data=NULL;
return_record=-1l;
pointer = fopen(MDATABASE_POINTER_FILE,"r+");
/* check if file is there */
if(pointer == NULL)
  {pointer = fopen(MDATABASE_POINTER_FILE,"a+");}

if(pointer!=NULL)
  {data = fopen(MDATABASE_FILE,"a+");
   if(data!=NULL)
     {new_data_ptr = data_ptr = ftell(data);
      records = (data_ptr/sizeof(fill));

      if(records<1)
        {/* no data yet */
         fseek(pointer,0l,SEEK_SET);
         fread(&data_ptr,MPOINTER_SIZE,1,pointer);
         fseek(data,data_ptr,SEEK_SET);
         /* get data and check */
         if(fread(&file_data,MRECORD_SIZE,1,data)==1)
           {/* COMPARE HERE */
            sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
            if(strcmp(tempfill,tempfile)==0)
              {return_record = 0l;
               /*printf("Found%s\n",file_data.call_sign);*/
              }
	   }
	}
        else
        {/* more than one record*/
         record_start=0l;
         record_end=(records-1);
         record_mid=(record_end-record_start)/2; 

         done=0;
         while(!done)
              {/*printf("Records Start %ld, Mid %ld, End %ld\n",record_start,record_mid,record_end);*/
               /* get data for record start */ 
               fseek(pointer,(MPOINTER_SIZE*record_start),SEEK_SET);
               fread(&data_ptr,MPOINTER_SIZE,1,pointer);
               fseek(data,data_ptr,SEEK_SET);
               if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                 {/* COMPARE HERE */
                  sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                  if(strcmp(tempfill,tempfile)<0)
                    {/* file name comes before */
                     /*printf("Before No data found!!\n");*/
                     done=1;
       		    }
                    else
                    {/* get data for record end */
                     fseek(pointer,(MPOINTER_SIZE*record_end),SEEK_SET);
                     fread(&data_ptr,MPOINTER_SIZE,1,pointer);
                     fseek(data,data_ptr,SEEK_SET);
                     if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                       {/* COMPARE HERE */
                        sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                        if(strcmp(tempfill,tempfile)>=0)
                          {/* COMPARE HERE */
                           if(strcmp(tempfill,tempfile)==0)
                             {return_record = record_end;
                              /*printf("Found %s\n",file_data.call_sign);*/
			     }
                             else
                             {/* file name comes After */
                              /*printf("After No data found!! %s %ld\n",file_data.call_sign,record_end);*/
			     }
                           done=1;
       			  }
                          else
                          {if((record_mid==record_start) || (record_mid==record_end))
                             {/* no mid for compare check to see if in the middle */
                              done=1;
                              fseek(pointer,(MPOINTER_SIZE*record_mid),SEEK_SET);
                              fread(&data_ptr,MPOINTER_SIZE,1,pointer);
                              fseek(data,data_ptr,SEEK_SET);
                              if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                                {/* COMPARE HERE */
                                 sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                                 if(strcmp(tempfill,tempfile)==0)
                                   {return_record = record_mid;
                                    /*printf("Found %s!!\n",file_data.call_sign);*/
				   }
				}
			     }
                             else
                             {/* get data for record mid */
                              fseek(pointer,(MPOINTER_SIZE*record_mid),SEEK_SET);
                              fread(&data_ptr,MPOINTER_SIZE,1,pointer);
                              fseek(data,data_ptr,SEEK_SET);
                              if(fread(&file_data,MRECORD_SIZE,1,data)==1)
                                {/* COMPARE HERE */
                                 sprintf(tempfile,"%s%s%s",file_data.call_sign,file_data.from_call_sign,file_data.seq);
                                 if(strcmp(tempfill,tempfile)<0)
                                   {/* checking  comes before */                        
                                    record_end=record_mid;
                                    record_mid=record_start+(record_end-record_start)/2; 
				   }
                                   else
                                   {/* ckecking come after*/
                                    record_start=record_mid;
                                    record_mid=record_start+(record_end-record_start)/2;
				   }
				}

			     }

			  }

		       }
		    }

		 }
	      }
	}
     }
     else
     {printf("Could not open file %s\n",MDATABASE_FILE);}
  }
  else
  {printf("Could not open file %s\n",MDATABASE_POINTER_FILE);}
if(data!=NULL)
  {fclose(data);}
if(pointer!=NULL)
  {fclose(pointer);}
return(return_record);
}



void mreplace_data(Message fill, long record_num)
{FILE *data;
 FILE *pointer;


long data_ptr;

data_ptr=0l;
data=NULL;
pointer = fopen(MDATABASE_POINTER_FILE,"r");
if(pointer!=NULL)
  {data = fopen(MDATABASE_FILE,"r+");
   if(data!=NULL)
     {fseek(pointer,(MPOINTER_SIZE*record_num),SEEK_SET);
      fread(&data_ptr,MPOINTER_SIZE,1,pointer);
      fseek(data,data_ptr,SEEK_SET);
      /* get data and check */
      if(fwrite(&fill,MRECORD_SIZE,1,data)==1)
        {/*printf("Change for %s \n",fill.call_sign);*/}
     }
     else
     {printf("Could not open file %s\n",MDATABASE_FILE);}
  }
  else
  {printf("Could not open file %s\n",MDATABASE_POINTER_FILE);}
if(data!=NULL)
  {fclose(data);}
if(pointer!=NULL)
  {fclose(pointer);}
}


void mget_data(Message *fill,long record_num)
{FILE *data;
 FILE *pointer;
 

long data_ptr;

data_ptr=0l;
data=NULL;
pointer = fopen(MDATABASE_POINTER_FILE,"r");
if(pointer!=NULL)
  {data = fopen(MDATABASE_FILE,"r");
   if(data!=NULL)
     {fseek(pointer,(MPOINTER_SIZE*record_num),SEEK_SET);
      fread(&data_ptr,MPOINTER_SIZE,1,pointer);
      fseek(data,data_ptr,SEEK_SET);
      /* get data and check */
      if(fread(fill,MRECORD_SIZE,1,data)==1)
        {/*printf("Get data for %s \n",*fill.call_sign);*/}
     }
     else
     {printf("Could not open file %s\n",MDATABASE_FILE);}
  }
  else
  {printf("Could not open file %s\n",MDATABASE_POINTER_FILE);}
if(data!=NULL)
  {fclose(data);}
if(pointer!=NULL)
  {fclose(pointer);}
}



void mdata_add(char *call_sign, char *from_call, char *data, char *seq, char type, char from)
{Message fill, fill_old;

long record;
int call_len;
char time_data[MAX_TIME];

strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
call_len=strlen(fill.call_sign);
if(fill.call_sign[(call_len-1)]=='*')
  {fill.call_sign[(call_len-1)]=0;}
strncpy(fill.from_call_sign,from_call,MAX_CALLSIGN);
strncpy(fill.seq,seq,MAX_MESSAGE_ORDER);

record = mfind_data(fill);
mclear_data(&fill);
if(record != -1l)
  {/* fill old data */
   mget_data(&fill,record);
   mcopy_data(&fill_old,&fill); 
  }

fill.sec_heard=sec_now();

/* FROM */
fill.data_via=from;
fill.active=RECORD_ACTIVE;
fill.type=type;
if (fill_old.heard_via_tnc != VIA_TNC)
   fill.heard_via_tnc = (from == 'T') ? VIA_TNC : NOT_VIA_TNC;
strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
strncpy(fill.from_call_sign,from_call,MAX_CALLSIGN);
strncpy(fill.message_line,data,MAX_MESSAGE_LENGTH);
strncpy(fill.seq,seq,MAX_MESSAGE_ORDER);
strcpy(fill.packet_time,get_time(time_data));

if(record == -1l)
  {minput_database(fill);}
  else
  {mreplace_data(fill,record);}
}

void  mclean_data_file(void)
{
unlink(MDATABASE_FILE);
unlink(MDATABASE_POINTER_FILE);
unlink(MDATABASE_POINTER_TEMP);
}


void update_messages(void)
{static XmTextPosition pos;
 char temp1[MAX_CALLSIGN+1];
 char temp2[500];
 char stemp[20];
 FILE *f_data;
 FILE *f_pointer;
 Message fill;
 long file_ptr;
 long i;
 long ptr;

 int mw_p;

 /* go through all mw_p's! */ 

 for(mw_p=0; mw_p<MAX_MESSAGE_WINDOWS; mw_p++)
    {i=0l;
     pos=0;
     if(mw[mw_p].send_message_dialog!=NULL/* && mw[mw_p].message_group==1*/)
       {strcpy(temp1,XmTextFieldGetString(mw[mw_p].send_message_call_data));
        new_message_data--;
        if(new_message_data<0)
          {new_message_data=0;}
        if(strlen(temp1)>0)
          {to_upper(temp1);
           f_pointer=fopen(MDATABASE_POINTER_FILE,"r");
           f_data=fopen(MDATABASE_FILE,"r");
           if(f_pointer!=NULL && f_data !=NULL)
             {XtVaSetValues(mw[mw_p].send_message_text,XmNcursorPosition,&pos,NULL);
              XmTextSetString(mw[mw_p].send_message_text,"");
              while(!feof(f_pointer))
                   {ptr=ftell(f_pointer);
                    if(fread(&file_ptr,sizeof(file_ptr),1,f_pointer)==1)
                      {fseek(f_data,file_ptr,SEEK_SET);
                       if(fread(&fill,sizeof(Message),1,f_data)==1)
                         {/*printf("Checking <%s> <%s> <%s> <%s>\n",temp1,fill.from_call_sign,mw[mw_p].to_call_sign,fill.call_sign);*/
                          if(strcmp(temp1,fill.from_call_sign)==0 || strcmp(mw[mw_p].to_call_sign,"***")==0)
                            {/*printf("Passed msg1\n");*/
                             if((strcmp(mw[mw_p].to_call_sign,fill.call_sign)==0 || strcmp(mw[mw_p].to_call_sign,"***")==0) && fill.active==RECORD_ACTIVE)
                               {/*printf("Passed msg2\n");*/
                                /*sprintf(temp2,"to <%s> from <%s>  seq %s type %c :%s\n",fill.call_sign,fill.from_call_sign,fill.seq,fill.type,fill.message_line);*/
                                /*sprintf(temp2,"%s:%s\n",fill.from_call_sign,fill.message_line);*/
                                sprintf(stemp,"%c%c/%c%c %c%c:%c%c",
                                              fill.packet_time[0],
                                              fill.packet_time[1],
                                              fill.packet_time[2],
                                              fill.packet_time[3],
                                              fill.packet_time[8],
                                              fill.packet_time[9],
                                              fill.packet_time[10],
                                              fill.packet_time[11]
                                              );
                                if(strcmp(mw[mw_p].to_call_sign,"***")==0)
                                  {if(strcmp(temp1,fill.call_sign)==0)
                                     {sprintf(temp2,"%s  %s>%s\n",stemp,fill.from_call_sign,fill.message_line);
                                      XmTextInsert(mw[mw_p].send_message_text,pos,temp2);
                                      pos=pos+strlen(temp2);
                                      XtVaSetValues(mw[mw_p].send_message_text,XmNcursorPosition,pos,NULL);
				     }
                                  }
                                  else
                                  {sprintf(temp2,"%s  %s\n",stemp,fill.message_line); 
                                   XmTextInsert(mw[mw_p].send_message_text,pos,temp2);
                                   pos=pos+strlen(temp2);
                                   XtVaSetValues(mw[mw_p].send_message_text,XmNcursorPosition,pos,NULL);
				  }
			       }
			    }
			 }
	    
                      i++;
		      }
		   }
	     }
          if(f_pointer!=NULL)
            {fclose(f_pointer);}
          if(f_data!=NULL)
            {fclose(f_data);}
          XmTextShowPosition(mw[mw_p].send_message_text,pos);  
	  }
       }
    }
}



void mdelete_messages_from(char *from)
{FILE *f_data;
 FILE *f_pointer;
 Message fill;
 long file_ptr;
 long ptr;

 f_pointer=fopen(MDATABASE_POINTER_FILE,"r");
 f_data=fopen(MDATABASE_FILE,"r");
 if(f_pointer!=NULL && f_data !=NULL)
   {while(!feof(f_pointer))
         {ptr=ftell(f_pointer);
          if(fread(&file_ptr,sizeof(file_ptr),1,f_pointer)==1)
            {fseek(f_data,file_ptr,SEEK_SET);
             if(fread(&fill,sizeof(Message),1,f_data)==1)
               {if(strcmp(fill.call_sign,my_callsign)==0 && strcmp(fill.from_call_sign,from)==0)
                  {fill.active=RECORD_NOTACTIVE;
                   mreplace_data(fill,(ptr/sizeof(ptr))); 
		  }
	       }
	    }
	 }
   
   }
if(f_pointer!=NULL)  
  {fclose(f_pointer);}
if(f_data!=NULL)
  {fclose(f_data);}
}

void mdelete_messages_to(char *to)
{FILE *f_data;
 FILE *f_pointer;
 Message fill;
 long file_ptr;
 long ptr;

 f_pointer=fopen(MDATABASE_POINTER_FILE,"r");
 f_data=fopen(MDATABASE_FILE,"r");
 if(f_pointer!=NULL && f_data !=NULL)
   {while(!feof(f_pointer))
         {ptr=ftell(f_pointer);
          if(fread(&file_ptr,sizeof(file_ptr),1,f_pointer)==1)
            {fseek(f_data,file_ptr,SEEK_SET);
             if(fread(&fill,sizeof(Message),1,f_data)==1)
               {if(strcmp(fill.call_sign,to)==0)
                  {fill.active=RECORD_NOTACTIVE;
                   mreplace_data(fill,(ptr/sizeof(ptr))); 
		  }
	       }
	    }
	 }
   
   }
if(f_pointer!=NULL)  
  {fclose(f_pointer);}
if(f_data!=NULL)
  {fclose(f_data);}
}

void mscan_file(char msg_type, void (*function)(Message *))
{
 FILE *f_data;
 FILE *f_pointer;
 Message fill;
 long file_ptr;
 long i;
 long ptr;

 i=0l;
 f_pointer=fopen(MDATABASE_POINTER_FILE,"r");
 f_data=fopen(MDATABASE_FILE,"r");
    if(f_pointer!=NULL && f_data !=NULL) {
	while(!feof(f_pointer))	{
	    ptr=ftell(f_pointer);
	    if(fread(&file_ptr,sizeof(file_ptr),1,f_pointer)==1) {
		fseek(f_data,file_ptr,SEEK_SET);
             if(fread(&fill,sizeof(Message),1,f_data)==1)
		  if (msg_type == '\0' || msg_type == fill.type)
		    function(&fill);
             i++;
	    }
	 }
   }
if(f_pointer!=NULL)  
  {fclose(f_pointer);}
if(f_data!=NULL)
  {fclose(f_data);}
}

void mprint_record(Message *fill)
{
    printf("%-9s<-%-9s seq:%5s type:%c :%s\n", fill->call_sign, fill->from_call_sign,
	   fill->seq, fill->type, fill->message_line);
}

void mdisplay_file(char msg_type)
{
    printf("\n\n");
    mscan_file(msg_type, mprint_record);
    printf("\n");
}

/****** STATION DATA *******/

#ifdef DATA_DEBUG
void clear_data(DataRow *clear)
{int size;
 int i;
 unsigned char *data_ptr;

 data_ptr = (unsigned char *)clear;
 size=sizeof(DataRow);
 for(i=0;i<size;i++)
    {*data_ptr++ = 0;}
}

void copy_data(DataRow *to, DataRow *from)
{int size;
 int i;
 unsigned char *data_ptr;
 unsigned char *data_ptr_from;

 data_ptr = (unsigned char *)to;
 data_ptr_from = (unsigned char *)from;
 size=sizeof(DataRow);
 for(i=0;i<size;i++)
    {*data_ptr++ = *data_ptr_from++;}
}
#endif /* DATA_DEBUG */

int look_for_powergain_in_comments(char *comments)
{
if(strncmp(comments,"PHG",3)==0)
  {if(isdigit(comments[3]) && isdigit(comments[4]) && isdigit(comments[5]) && isdigit(comments[6]))
     {return(1);}
  }
return(0);
}

int look_for_altitude_in_comments(char *comments)
{int i,ii,ok;

ok=0;
for(ii=0; ii<strlen(comments) && !ok;ii++)
   {if(strncmp(comments+ii,"/A=",3)==0)
      {ok=1;}
   }
if(ok)
  {for(i=0;i<6 && ok==1;i++)
      {if(!isdigit(comments[2+i+ii]) && comments[3+i+ii]!='-')
         {ok=0;}
      }
   if(ok)
     {ok=ii+2;}
  }
return(ok);
}

int look_for_omnidf_in_comments(char *comments)
{
if(strncmp(comments,"DFS",3)==0)
  {return(1);}
return(0);
}

void pad_callsign(char *callsignout, char *callsignin)
{int i,l;

l=strlen(callsignin);
for(i=0; i<9;i++)
   {if(i<l)
      {if(isalnum(callsignin[i]) || callsignin[i]=='-')
         {callsignout[i]=callsignin[i];}
         else
         {callsignout[i]=' ';}
      }
      else
      {callsignout[i]=' ';}
   }
callsignout[i]=0;
}

APRS_Symbol *id_callsign(char *call_sign, char * to_call)
{
char *ptr;
 char *id = "/aUfbYX's><OjRkv";
 char hold[MAX_CALLSIGN+1];
 int index;
 static APRS_Symbol symbol;

 symbol.aprs_symbol = '/';
 symbol.special_overlay = '\0';
 symbol.aprs_type ='/';
ptr=strchr(call_sign,'-');
if(ptr!=NULL)
 {if((index=atoi(ptr+1))<= 15)
         {
          symbol.aprs_symbol = id[index];
    	 }

 }
 if (strncmp(to_call, "GPS", 3) == 0 || strncmp(to_call, "SPC", 3) == 0 ||
     strncmp(to_call, "SYM", 3) == 0) {
     strncpy(hold, to_call+3, 3);
     hold[3] = '\0';
     if ((ptr = strpbrk(hold, "->,")) != NULL) *ptr = '\0';
     if (strlen(hold) >= 2) 
	{
         switch (hold[0]) 
          {
	   case 'A':
	     symbol.aprs_type = '\\';
	   case 'P':
	     if (('0' <= hold[1] && hold[1] <= '9') || ('A' <= hold[1] && hold[1] <= 'Z'))
	       symbol.aprs_symbol = hold[1];
                  break;
	   case 'O':
	     symbol.aprs_type = '\\';
	   case 'B':
	     switch (hold[1]) 
              {
	       case 'B': symbol.aprs_symbol = '!';
                  break;
	       case 'C': symbol.aprs_symbol = '"';
                  break;
	       case 'D': symbol.aprs_symbol = '#';
                  break;
	       case 'E': symbol.aprs_symbol = '$';
                  break;
	       case 'F': symbol.aprs_symbol = '%';
                  break;
	       case 'G': symbol.aprs_symbol = '&';
                  break;
	       case 'H': symbol.aprs_symbol = '\'';
                  break;
	       case 'I': symbol.aprs_symbol = '(';
                  break;
	       case 'J': symbol.aprs_symbol = ')';
                  break;
	       case 'K': symbol.aprs_symbol = '*';
                  break;
	       case 'L': symbol.aprs_symbol = '+';
                  break;
	       case 'M': symbol.aprs_symbol = ',';
                  break;
	       case 'N': symbol.aprs_symbol = '-';
                  break;
	       case 'O': symbol.aprs_symbol = '.';
		 break;
	       case 'P': symbol.aprs_symbol = '/';
                  break;
	      }
           break;

	   case 'D':
	     symbol.aprs_type = '\\';
	   case 'H':
	     switch (hold[1]) 
	      {
               case 'S': symbol.aprs_symbol = '[';
		 break;
	       case 'T': symbol.aprs_symbol = '\\';
		 break;
	       case 'U': symbol.aprs_symbol = ']';
		 break;
	       case 'V': symbol.aprs_symbol = '^';
		 break;
	       case 'W': symbol.aprs_symbol = '_';
		 break;
	       case 'X': symbol.aprs_symbol = '`';
		 break;
	      }
           break;

	   case 'N':
	     symbol.aprs_type = '\\';
	   case 'M':
	     switch (hold[1]) 
              {
	       case 'R': symbol.aprs_symbol = ':';
		 break;
	       case 'S': symbol.aprs_symbol = ';';
		 break;
	       case 'T': symbol.aprs_symbol = '<';
		 break;
	       case 'U': symbol.aprs_symbol = '=';
		 break;
	       case 'V': symbol.aprs_symbol = '>';
		 break;
	       case 'W': symbol.aprs_symbol = '?';
		 break;
	       case 'X': symbol.aprs_symbol = '@';
		 break;
	      }
             break;

	   case 'Q':
	     symbol.aprs_type = '\\';
	   case 'J':
	     switch (hold[1]) 
              {
	       case '1': symbol.aprs_symbol = '{';
		 break;
	       case '2': symbol.aprs_symbol = '|';
		 break;
	       case '3': symbol.aprs_symbol = '}';
		 break;
	       case '4': symbol.aprs_symbol = '~';
		 break;
	      }
             break;

	   case 'S':
	    symbol.aprs_type = '\\';
	   case 'L':
	     if ('A' <= hold[1] && hold[1] <= 'Z')
	     symbol.aprs_symbol = tolower(hold[1]);
	     break;
	  }
     if (hold[2]) symbol.special_overlay = hold[2];
     }
 }	 
return(&symbol);
}

void mem_display(void)
{int i;

for(i=0;i<stations;i++)
   {printf("Station %s %d\n",station_data[station_ptr[i]].call_sign,station_ptr[i]);}

}

void mem_reset_pointers(int new_data_ptr, int stations, int type, int start_ptr)
{int buffn;

if(type==0)
  {/* before start_ptr */
   /* copy back pointers */
   for(buffn=stations; buffn >= start_ptr; buffn-=1)
      {/*printf("Copy %s %d to %s %d\n",station_data[station_ptr[buffn]].call_sign,buffn,station_data[station_ptr[buffn+1]].call_sign,buffn+1);*/
       station_ptr[(buffn+1)]=station_ptr[buffn];}
   station_ptr[start_ptr]=new_data_ptr;
  }
}

/******************************** Sort begin *************************** ****/

void  clear_sort_file(char *filename)
{char ptr_filename[400];

sprintf(ptr_filename,"%s-ptr",filename);
unlink(filename);
unlink(ptr_filename);
}

void sort_reset_pointers(FILE *pointer,long new_data_ptr,long records, int type, long start_ptr)
{long cp;
 long temp[13000];
 long buffn,start_buffn;
 long cp_records; 
 long max_buffer;
 int size;

size=sizeof(new_data_ptr);
max_buffer=13000l;
if(type==0)
  {/* before start_ptr */
   /* copy back pointers */
   cp=start_ptr;
   for(buffn=records; buffn > start_ptr; buffn-=max_buffer)
      {start_buffn=buffn-max_buffer;
       if(start_buffn<start_ptr)
         {start_buffn=start_ptr;}
       cp_records=buffn-start_buffn;
       fseek(pointer,(size*start_buffn),SEEK_SET);
       if(fread(&temp,(size*cp_records),1,pointer)==1)
         {fseek(pointer,(size*(start_buffn+1)),SEEK_SET);
          fwrite(&temp,(size*cp_records),1,pointer);
	 }
      }    
   /* copy new pointer in */
   fseek(pointer,(size*start_ptr),SEEK_SET);
   fwrite(&new_data_ptr,size,1,pointer);
  }
}

long sort_input_database(char *filename, char *fill, int size)
{FILE *data;
 FILE *pointer;
 char file_data[2000];
 
 char ptr_filename[400];

 char tempfile[2000];
 char tempfill[2000];

int ptr_size;
long data_ptr;
long new_data_ptr;
long return_records;
long records;
long record_start;
long record_end;
long record_mid;
int done;


/* end fill anyway */
fill[strlen(fill)]=0;
ptr_size=sizeof(new_data_ptr);
sprintf(ptr_filename,"%s-ptr",filename);
/* get first string to sort on */
sscanf(fill,"%s",tempfill);

data_ptr=0l;
data=NULL;
return_records=0l;
pointer = fopen(ptr_filename,"r+");
/* check if file is there */
if(pointer == NULL)
  {pointer = fopen(ptr_filename,"a+");}

if(pointer!=NULL)
  {data = fopen(filename,"a+");
   if(data!=NULL)
     {new_data_ptr = data_ptr = ftell(data);
      fwrite(fill,size,1,data);
      records = (data_ptr/size);
      return_records=records+1;
      if(records<1)
        {/* no data yet */
         fseek(pointer,0l,SEEK_SET);
         fwrite(&data_ptr,ptr_size,1,pointer);
	}
        else
        {/* more than one record*/
         fseek(pointer,(ptr_size*records),SEEK_SET);
         fwrite(&data_ptr,ptr_size,1,pointer);
         record_start=0l;
         record_end=records;
         record_mid=(record_end-record_start)/2; 

         done=0;
         while(!done)
              {/*printf("Records Start %ld, Mid %ld, End %ld\n",record_start,record_mid,record_end);*/
               /* get data for record start */
               fseek(pointer,(ptr_size*record_start),SEEK_SET);
               fread(&data_ptr,ptr_size,1,pointer);
               fseek(data,data_ptr,SEEK_SET);
               if(fread(file_data,size,1,data)==1)
                 {/* COMPARE HERE */
                  sscanf(file_data,"%s",tempfile);
                  if(strcmp(tempfill,tempfile)<0) 
                    {/* file name comes before */
                     /*printf("END - Before start\n");*/
                     done=1;
                     /* now place pointer before start*/
                     sort_reset_pointers(pointer,new_data_ptr,records,0,record_start); 
		    }
                    else
                    {/* get data for record end */  
                     fseek(pointer,(ptr_size*record_end),SEEK_SET);
                     fread(&data_ptr,ptr_size,1,pointer);
                     fseek(data,data_ptr,SEEK_SET);
                     if(fread(file_data,size,1,data)==1)
                       {/* COMPARE HERE */
                        sscanf(file_data,"%s",tempfile);
                        if(strcmp(tempfill,tempfile)>0)
                          {/* file name comes after */
                           /*printf("END - After end\n");*/
                           done=1;
                           /* now place pointer after end */

			  }
                          else
                          {if((record_mid==record_start) || (record_mid==record_end))
                             {/* no mid for compare check to see if in the middle */
                              /*printf("END - NO Middle\n");*/ 
                              done=1;
                              /* now place pointer before start*/
                              if(record_mid==record_start)
                                {sort_reset_pointers(pointer,new_data_ptr,records,0,record_mid+1);}
                                else 
                                {sort_reset_pointers(pointer,new_data_ptr,records,0,record_mid-1);}
			     }
                             else
                             {/* get data for record mid */
                              fseek(pointer,(ptr_size*record_mid),SEEK_SET);
                              fread(&data_ptr,ptr_size,1,pointer);
                              fseek(data,data_ptr,SEEK_SET);
                              if(fread(file_data,size,1,data)==1)
                                {/* COMPARE HERE */
                                 sscanf(file_data,"%s",tempfile);
                                 if(strcmp(tempfill,tempfile)<0)
                                   {/* checking  comes before */
                                    /*record_start=0l;*/
                                    record_end=record_mid;
                                    record_mid=record_start+(record_end-record_start)/2; 
                                    /*printf("TOP %ld, mid %ld\n",record_mid,record_end);*/     
				   }
                                   else
                                   {/* ckecking come after*/
                                    record_start=record_mid;
                                    /*record_end=end*/
                                    record_mid=record_start+(record_end-record_start)/2;
                                    /*printf("BOTTOM start %ld, mid %ld\n",record_start,record_mid);*/     
				   }
				}

			     }

			  }

		       }
		    }

		 }
	      }
	}
     }
     else
     {printf("Could not open file %s\n",filename);}
  }
  else
  {printf("Could not open file %s\n",filename);}
if(data!=NULL)
  {fclose(data);}
if(pointer!=NULL)
  {fclose(pointer);}
return(return_records);
}

void sort_display_file(char *filename,int size)
{FILE *f_data;
 FILE *f_pointer;
 char fill[2000];
 long file_ptr;
 long i;
 long ptr;
 char ptr_filename[400];

 sprintf(ptr_filename,"%s-ptr",filename);
 printf("\n");
 i=0l;
 f_pointer=fopen(ptr_filename,"r");
 f_data=fopen(filename,"r");
 if(f_pointer!=NULL && f_data !=NULL)
   {while(!feof(f_pointer))
         {ptr=ftell(f_pointer);
          if(fread(&file_ptr,sizeof(file_ptr),1,f_pointer)==1)
            {fseek(f_data,file_ptr,SEEK_SET);
             printf("%ld:",file_ptr);
             if(fread(fill,size,1,f_data)==1)
               {printf("%s\n",fill);}
             i++;
	    }
	 }
   
   }
if(f_pointer!=NULL)  
  {fclose(f_pointer);}
if(f_data!=NULL)
  {fclose(f_data);}
printf("\n\n");
}


/******************** sort end **********************/

void display_file(Widget w)
{DataRow fill;
 char temp_long[20];
 char temp_lat[20];
 char temp_altitude[20];
 char temp_course[20];
 char temp_speed[20];
 char temp_call[20];
 char wx_tm[50];
 char temp_wx_temp[30];
 char temp_wx_wind[40];
 char temp_my_distance[20];
 char temp_my_course[20];
 char temp1_my_course[20];
 char temp_type;
 char temp_symbol;
 char temp_overlay;
 time_t temp_sec_heard;
 int data_ptr_i;
 int got_data;
 int iii;
 unsigned char short_dashed[2] = {1,5};
 unsigned char medium_dashed[2] = {5,5};
 /*long x_long, y_lat;*/
 long x_diff_long, y_diff_lat;
 long x_origin, y_origin,x,y,max_x,max_y;

 if(debug_level & 1)
   {printf("Display File Start\n");}

 strcpy(temp_altitude,"");
 strcpy(temp_course,"");
 strcpy(temp_speed,"");
 strcpy(temp_my_distance,"");
 strcpy(temp_my_course,"");
 strcpy(temp1_my_course,"");
 if(debug_level & 2)
   {printf("Display File 1\n");}
 temp_sec_heard=0l;
 got_data=0;

 for(data_ptr_i=0;data_ptr_i<stations;data_ptr_i++)
    {copy_data(&fill,&station_data[station_ptr[data_ptr_i]]);    
     if(fill.active == RECORD_ACTIVE)
       {strcpy(temp_altitude,"");
        strcpy(temp_course,"");
        strcpy(temp_speed,"");
        strcpy(temp_my_distance,"");
        strcpy(temp_my_course,"");
        strcpy(temp_wx_temp,"");
        strcpy(temp_wx_wind,"");
        temp_sec_heard=0l;
	  
        strcpy(temp_call,fill.call_sign);
        temp_type = fill.aprs_symbol.aprs_type;
        temp_symbol = fill.aprs_symbol.aprs_symbol;
        temp_overlay = fill.aprs_symbol.special_overlay;

        if(fill.wx_data==1)
          {if(!units_english_metric)
             {if(strlen(fill.wx_temp)>1)
                 {sprintf(wx_tm,"T:%03d C",(int)(((atof(fill.wx_temp)-32)*5.0)/9.0));
                  strcat(temp_wx_temp,wx_tm);
                 }
              if(strlen(fill.wx_hum)>1)
                {if(strlen(fill.wx_temp)>1)
                   {strcat(temp_wx_temp,"  ");}
                 sprintf(wx_tm,"H:%s%%",fill.wx_hum);
                 strcat(temp_wx_temp,wx_tm);
		}

              if(strlen(fill.wx_speed)>1)
                 {sprintf(wx_tm,"S:%03d Kph",(int)(atof(fill.wx_speed)*1.6094));
                  strcat(temp_wx_wind,wx_tm);
                 }
              if(strlen(fill.wx_gust)>1)
                {if(strlen(fill.wx_speed)>1)
                   {strcat(temp_wx_wind," ");}
                 sprintf(wx_tm,"G:%03d Kph",(int)(atof(fill.wx_gust)*1.6094));
                 strcat(temp_wx_wind,wx_tm);
		}
              if(strlen(fill.wx_course)>1)
                {if(strlen(fill.wx_speed)>1 || strlen(fill.wx_gust)>1)
                   {strcat(temp_wx_wind," ");}
                 sprintf(wx_tm,"C:%s",fill.wx_course);
                 strcat(temp_wx_wind,wx_tm);
		}
	     }
             else
             {if(strlen(fill.wx_temp)>1)
                 {sprintf(wx_tm,"T:%s F",fill.wx_temp);
                  strcat(temp_wx_temp,wx_tm);
                 }
              if(strlen(fill.wx_hum)>1)
                {if(strlen(fill.wx_temp)>1)
                   {strcat(temp_wx_temp,"  ");}
                 sprintf(wx_tm,"H:%s%%",fill.wx_hum);
                 strcat(temp_wx_temp,wx_tm);
		}

              if(strlen(fill.wx_speed)>1)
                 {sprintf(wx_tm,"S:%s Mph",fill.wx_speed);
                  strcat(temp_wx_wind,wx_tm);
                 }
              if(strlen(fill.wx_gust)>1)
                {if(strlen(fill.wx_speed)>1)
                   {strcat(temp_wx_wind," ");}
                 sprintf(wx_tm,"G:%s Mph",fill.wx_gust);
                 strcat(temp_wx_wind,wx_tm);
		}
              if(strlen(fill.wx_course)>1)
                {if(strlen(fill.wx_speed)>1 || strlen(fill.wx_gust)>1)
                   {strcat(temp_wx_wind," ");}
                 sprintf(wx_tm,"C:%s",fill.wx_course);
                 strcat(temp_wx_wind,wx_tm);
		}
	     }
	  }

        if(strcmp(fill.call_sign,my_callsign)!=0)
          {temp_sec_heard = fill.sec_heard;}
          else
          {temp_sec_heard = sec_now();}
                      
        if(strlen(fill.altitude)>0 && symbol_alt_display)
          {if(!units_english_metric)
             {sprintf(temp_altitude,"%s %c",fill.altitude,fill.alt_unit);}
             else
             {sprintf(temp_altitude,"%.1f %s",atof(fill.altitude)*3.28084,"Ft");}
  	  }

        if(strlen(fill.course)>0 && symbol_course_display)
          {sprintf(temp_course,"%s Deg",fill.course);}

        if(strlen(fill.speed)>0 && symbol_speed_display)
          {if(!units_english_metric)
             {sprintf(temp_speed,"%.1f KPH",atof(fill.speed)*1.852);}
             else
             {sprintf(temp_speed,"%.1f MPH",atof(fill.speed)*1.1508);}
                     
	  }

        /* do my course */
        if(strcmp(fill.call_sign,my_callsign)!=0 && symbol_dist_course_display)
          {sprintf(temp_long,"%s%c",fill.long_pos_x,fill.long_ew);
           sprintf(temp_lat,"%s%c",fill.lat_pos_y,fill.lat_ns);
           if(units_english_metric)
             {sprintf(temp_my_distance,"%0.1f Miles",(distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.15078));}
             else
             {sprintf(temp_my_distance,"%0.1f Km",(distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.852));}
           sprintf(temp_my_course,"%s Deg",temp1_my_course);
	  }

       /* see if this station is old */
       if((sec_clear+temp_sec_heard)>sec_now())                /* Not too old, so draw tracks */
         {if(station_trails)
            {if(fill.num_trail>1)
               {XSetForeground(XtDisplay(w),gc,trail_colors[fill.trail_color]);

                if ((sec_old+temp_sec_heard)>sec_now()) /* New track, so draw solid track */
                {       /* Used to be "JoinMiter" and "CapButt" below */
                  XSetLineAttributes(XtDisplay(w), gc, 3, LineSolid, CapRound, JoinRound);
                }
                else    /* Old, but not old enough to clear it.  Draw dashed track. */
                {       /* Another choice is LineDoubleDash */
                  XSetLineAttributes(XtDisplay(w), gc, 3, LineOnOffDash, CapRound, JoinRound);                  
                  XSetDashes(XtDisplay(w), gc, 0, short_dashed , 2);
                }  

                /* max off screen values */
                max_x = screen_width+800l;
                max_y = screen_height+800l;

                for(iii=0; iii<(fill.num_trail-1); iii++)
                   {x_origin = ((fill.trail_long_pos[(iii+1)]-x_long_offset)/size);
                    y_origin = ((fill.trail_lat_pos[(iii+1)]-y_lat_offset)/size);
                    x = ((fill.trail_long_pos[iii]-x_long_offset)/size);
                    y = ((fill.trail_lat_pos[iii]-y_lat_offset)/size);

                    /* REJECT LONG LINES */ 
                    x_diff_long= labs(x_origin-x);      
                    y_diff_lat = labs(y_origin-y);

                    if((x_diff_long < ((long)screen_width*3l)) && (y_diff_lat < ((long)screen_height)*3))
                      {if(x_origin > (-800l) && (x_origin< max_x))
		         {if(y_origin > (-800l) && (y_origin< max_y))
	                    {if(x > (-800l) && (x< max_x))
	                       {if(y > (-800l) && (y< max_y))
				  {XDrawLine(XtDisplay(w), pixmap_final, gc, x_origin, y_origin, x, y);}  
			       }
			    }
			 }
		      }
		   }
	       }
	    }
	 }
       XSetDashes(XtDisplay(w), gc, 0, medium_dashed , 2);
       draw_symbol(w,temp_type,temp_symbol,temp_overlay,fill.long_pos,fill.lat_pos,
                temp_call,temp_altitude,temp_course,temp_speed,temp_my_distance,temp_my_course,temp_wx_temp,temp_wx_wind,
                temp_sec_heard,pixmap_final);

       if(strlen(fill.power_gain)>3 && show_phg)
         {/*printf("PHG:%s\n",fill.power_gain);*/
          draw_phg(fill.long_pos,fill.lat_pos,fill.power_gain,temp_sec_heard,pixmap_final);
	 }

       }
    }

 if(debug_level & 1)
   {printf("Display File Stop\n");}
}

/************************** Clear tracks *********************************/
/*************************************************************************/

void Tracks_All_Clear(Widget w, XtPointer clientData, XtPointer callData)
{
  int i;

  for (i=0; i < stations; i++)
  {
    station_data[i].num_trail = 0;
  }
  redraw_on_new_data=2;
}        

/******** station info box **********/

void Station_data_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{
 Widget shell = (Widget) clientData;
 XtPopdown(shell);
 XtDestroyWidget(shell);
 station_info = (Widget)NULL;
}


static int destroy_track_pointer;

void Station_data_destroy_track(Widget widget, XtPointer clientData, XtPointer callData)
{
 station_data[destroy_track_pointer].num_trail = 0;
 redraw_on_new_data = 2;
}

void Station_data_add_fcc(Widget w, XtPointer clientData, XtPointer calldata)
{char temp[500];
 FccAppl data;
 char *station = (char *) clientData;

check_fcc_data();
busy_cursor(XtParent(w));
if(search_fcc_data_appl(station, &data)==1)
  {/*printf("FCC call %s\n",station);*/                                            
   sprintf(temp,"%s\n%s %s\n%s %s %s\n%s %s, %s %s, %s %s\n\n",
              langcode("STIFCC0001"),
              langcode("STIFCC0003"),data.name_licensee,
              langcode("STIFCC0004"),data.text_street,data.text_pobox,
              langcode("STIFCC0005"),data.city,
              langcode("STIFCC0006"),data.state,
              langcode("STIFCC0007"),data.zipcode);
   XmTextInsert(si_text,0,temp);
  }
}

void Station_data_add_rac(Widget w, XtPointer clientData, XtPointer calldata)
{
char temp[512];
char club[512];
rac_record data;
char *station = (char *) clientData;

strncpy(temp," ",sizeof(temp));
check_rac_data();
busy_cursor(XtParent(w));
if(search_rac_data(station, &data)==1)
  {/*printf("IC call %s\n",station);*/

/*   sprintf(temp,"RAC Database Lookup\n%15.15s %20.20s\n%31.31s\n%20.20s\n%2.2s %7.7s\n", */
   sprintf(temp,"%s\n%s %s\n%s\n%s, %s\n%s\n",
          langcode("STIFCC0002"),
          data.first_name,data.last_name,data.address,data.city,data.province,data.postal_code);
   if (data.qual_a[0] == 'A'){
        strcat(temp,langcode("STIFCC0008"));
   }
   if (data.qual_d[0] == 'D'){
        strcat(temp,langcode("STIFCC0009"));
   }
   if (data.qual_b[0] == 'B' && data.qual_c[0] != 'C'){
        strcat(temp,langcode("STIFCC0010"));
   }
   if (data.qual_c[0] == 'C'){
        strcat(temp,langcode("STIFCC0011"));
   }
   strcat(temp,"\n");

if (strlen(data.club_name) > 1){
        sprintf(club,"%s\n%s\n%s, %s\n%s\n",
        data.club_name,data.club_address,data.club_city,data.club_province,data.club_postal_code);
        strcat(temp,club);
}
strcat(temp,"\n");
   XmTextInsert(si_text,0,temp);
  }
}


void Station_data(Widget w, XtPointer clientData, XtPointer calldata)
{char *station = (char *) clientData;
 int data_ptr_i;
 char temp[300];
 int pos, last_pos;
 int n,found;
 Atom delw;
 static Widget  pane, form, button_cancel, button_message, button_fcc, 
                button_rac, button_clear_track, station_icon, station_call;
 Arg args[20];
 int last;
 char temp_long[20];
 char temp_lat[20];
 char temp_my_distance[20];
 char temp_my_course[20];
 char temp1_my_course[20];
 float temp_out_C, e, humidex;
 Pixmap icon; 

found=0;
temp_out_C=0;

pos=0;
if(station_info!=NULL)
  {Station_data_destroy_shell(station_info, station_info, NULL);}

if(station_info==NULL)
  {station_info = XtVaCreatePopupShell(langcode("WPUPSTI001"),xmDialogShellWidgetClass,GetTopShell(w),
                                  XmNdeleteResponse,XmDESTROY,
                                  XmNdefaultPosition, False,
                                  NULL);

   pane = XtVaCreateWidget("pane",xmPanedWindowWidgetClass, station_info,
                          XmNsashWidth, 1,
                          XmNsashHeight, 1,
                         NULL);


   form =  XtVaCreateWidget("form2",xmFormWidgetClass,pane,
                            XmNfractionBase, 5,
                            NULL);


   
   for(data_ptr_i=0;data_ptr_i<stations;data_ptr_i++)
      {if(station_data[data_ptr_i].active == RECORD_ACTIVE)
         {if(strcmp(station, station_data[data_ptr_i].call_sign)==0)
            {found = data_ptr_i;
             data_ptr_i=stations+1;

             icon = XCreatePixmap(XtDisplay(appshell),RootWindowOfScreen(XtScreen(appshell)),20,20,DefaultDepthOfScreen(XtScreen(appshell)));

             symbol(station_info,0,station_data[found].aprs_symbol.aprs_type,
                    station_data[found].aprs_symbol.aprs_symbol,
                    station_data[found].aprs_symbol.special_overlay,icon,0,0,0);

             station_icon = XtVaCreateManagedWidget("icon", xmLabelWidgetClass, form,
                                      XmNtopAttachment, XmATTACH_FORM,
                                      XmNtopOffset, 2,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNlabelType, XmPIXMAP,
                                      XmNlabelPixmap,icon,
                                      NULL);

             station_call = XtVaCreateManagedWidget("call", xmTextFieldWidgetClass, form,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNshadowThickness,       0,
                                      XmNcolumns,15,
                                      XmNwidth,((15*7)+2),
                                      XmNbackground, colors[0xff],
                                      XmNtopAttachment,XmATTACH_FORM,
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget,station_icon,
                                      XmNleftOffset,10,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);  
             XmTextFieldSetString(station_call,station_data[found].call_sign);
             XtManageChild(station_call);
 
             n=0;
             XtSetArg(args[n], XmNrows, 10); n++;
             XtSetArg(args[n], XmNcolumns, 100); n++;
             XtSetArg(args[n], XmNeditable, False); n++;
             XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
             XtSetArg(args[n], XmNwordWrap, True); n++;
             XtSetArg(args[n], XmNbackground, colors[0x0f]); n++;
             XtSetArg(args[n], XmNscrollHorizontal, False); n++;
             XtSetArg(args[n], XmNshowAsDefault, True); n++;
             XtSetArg(args[n], XmNcursorPositionVisible, False); n++;



             si_text = NULL;
             si_text = XmCreateScrolledText(form,"Station Data",args,n);
             XtVaSetValues(XtParent(si_text),
                           XmNtopAttachment, XmATTACH_WIDGET,
                           XmNtopWidget, station_icon,
                           XmNtopOffset, 5,
                           XmNbottomAttachment, XmATTACH_NONE,
                           XmNleftAttachment, XmATTACH_FORM,
                           XmNrightAttachment, XmATTACH_FORM,
                           NULL);



             sprintf(temp,langcode("WPUPSTI005"),station_data[found].num_packets);
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             strncpy(temp,station_data[found].packet_time,2);
             temp[2]='/';
             temp[3]=0;
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             strncpy(temp,station_data[found].packet_time+2,2);
             temp[2]='/';
             temp[3]=0;
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             strncpy(temp,station_data[found].packet_time+4,4);
             temp[4]=' ';
             temp[5]=0;
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             strncpy(temp,station_data[found].packet_time+8,2);
             temp[2]=':';
             temp[3]=0;
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             strncpy(temp,station_data[found].packet_time+10,2);
             temp[2]=':';
             temp[3]=0;
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             strncpy(temp,station_data[found].packet_time+12,2);
             temp[2]='\n';
             temp[3]=0;
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             if(station_data[found].heard_via_tnc==VIA_TNC)
               {sprintf(temp,langcode("WPUPSTI006"),station_data[found].heard_via_tnc_port);
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
	       }
               else
               {sprintf(temp,langcode("WPUPSTI007"));
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
	       }

             switch(station_data[found].data_via)
                   {case('L'):sprintf(temp,langcode("WPUPSTI008"));
                              break;

                    case('T'):sprintf(temp,langcode("WPUPSTI009"),station_data[found].last_port_heard);
                              break;

                    case('I'):sprintf(temp,langcode("WPUPSTI010"),station_data[found].last_port_heard);
                              break;

                    case('F'):sprintf(temp,langcode("WPUPSTI011"));
                              break;

                    default:  sprintf(temp,langcode("WPUPSTI012"));
                              break;
		   }

             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             if(station_data[found].moving==1)
               {sprintf(temp,langcode("WPUPSTI013"));
                sprintf(temp,"\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 
               }
               else
               {sprintf(temp,"\n");}
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);


             sprintf(temp,langcode("WPUPSTI014"),station_data[found].power_gain);
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp); 
             sprintf(temp,"\n");
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);  

             last_pos=pos;
             if(strlen(station_data[found].altitude)>0)
               {if(!units_english_metric)
                  {sprintf(temp,langcode("WPUPSTI015"),station_data[found].altitude,station_data[found].alt_unit);}
                  else
                  {sprintf(temp,langcode("WPUPSTI016"),atof(station_data[found].altitude)*3.28084,"Ft");}
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
	       }

             if(strlen(station_data[found].course)>0)
               {sprintf(temp,langcode("WPUPSTI017"),station_data[found].course);
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
                }

             if(strlen(station_data[found].speed)>0)
               {if(!units_english_metric)
                  {sprintf(temp,langcode("WPUPSTI018"),atof(station_data[found].speed)*1.852);}
                  else
                  {sprintf(temp,langcode("WPUPSTI019"),atof(station_data[found].speed)*1.1508);}               
               
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
	       }

             if(last_pos!=pos)
               {sprintf(temp,"\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
               }

             last_pos=pos;  
             /* do my course */
             if(strcmp(station_data[found].call_sign,my_callsign)!=0)
               {sprintf(temp_long,"%s%c",station_data[found].long_pos_x,station_data[found].long_ew);
                sprintf(temp_lat,"%s%c",station_data[found].lat_pos_y,station_data[found].lat_ns);
                if(units_english_metric)
                  {sprintf(temp_my_distance,langcode("WPUPSTI020"),(distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.15078));}
                  else
                  {sprintf(temp_my_distance,langcode("WPUPSTI021"),(distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.852));}
                sprintf(temp_my_course,"%s Deg",temp1_my_course);
                sprintf(temp,langcode("WPUPSTI022"),temp_my_distance,temp_my_course);
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
	       }

             if(last_pos!=pos)
               {sprintf(temp,"\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
               }

             sprintf(temp,langcode("WPUPSTI023"));
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);
             
             convert_long_lat_string(station_data[found].lat_pos, temp);
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             sprintf(temp,"  ");
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             convert_long_long_string(station_data[found].long_pos, temp);
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             sprintf(temp,"\n");
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp);

             for(last=0; last<station_data[found].num_trail; last++)
                {sprintf(temp,"               ");
                 XmTextInsert(si_text,pos,temp);
                 pos=pos+strlen(temp);
             
                 convert_long_lat_string(station_data[found].trail_lat_pos[last], temp);
                 XmTextInsert(si_text,pos,temp);
                 pos=pos+strlen(temp);

                 sprintf(temp,"  ");
                 XmTextInsert(si_text,pos,temp);
                 pos=pos+strlen(temp);

                 convert_long_long_string(station_data[found].trail_long_pos[last], temp);
                 XmTextInsert(si_text,pos,temp);
                 pos=pos+strlen(temp);

                 sprintf(temp,"\n");
                 XmTextInsert(si_text,pos,temp);
                 pos=pos+strlen(temp);
		}

             if(station_data[found].wx_data==1)
               {sprintf(temp,"\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 
                sprintf(temp,langcode("WPUPSTI024"),station_data[found].wx_type,station_data[found].wx_station);
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 
                sprintf(temp,"\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 

                if(!units_english_metric)
                  {sprintf(temp,langcode("WPUPSTI025"),station_data[found].wx_course,(int)(atof(station_data[found].wx_speed)*1.6094));}
                  else
                  {sprintf(temp,langcode("WPUPSTI026"),station_data[found].wx_course,station_data[found].wx_speed);}

                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 

                if(station_data[found].wx_gust_on == 1)
                  {if(!units_english_metric)
                     {sprintf(temp,langcode("WPUPSTI027"),(int)(atof(station_data[found].wx_gust)*1.6094));}
                     else
                     {sprintf(temp,langcode("WPUPSTI028"),station_data[found].wx_gust);}
                   strcat(temp,"\n");
		  }
                  else
                  {sprintf(temp," \n");}
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 

                last_pos=pos;   
                if(station_data[found].wx_temp_on == 1)
                  {if(!units_english_metric)
                     {temp_out_C =(((atof(station_data[found].wx_temp)-32)*5.0)/9.0); 
                      sprintf(temp,langcode("WPUPSTI029"),temp_out_C);
                     }
                     else
                     {sprintf(temp,langcode("WPUPSTI030"),station_data[found].wx_temp);}
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp);
		  }

                if(station_data[found].wx_hum_on == 1)
                  {sprintf(temp,langcode("WPUPSTI031"),station_data[found].wx_hum);
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
		  }

               if((station_data[found].wx_hum_on == 1) && 
                  (station_data[found].wx_temp_on == 1) && 
                  (!units_english_metric) &&
                  (atof(station_data[found].wx_hum)> 0.0)
                 )
                 {e = 6.112 * pow(10,(7.5 * temp_out_C)/(237.7 + temp_out_C)) * atof(station_data[found].wx_hum) / 100.0;
                  humidex = (temp_out_C + ((5.0/9.0) * (e-10.0)));

                  sprintf(temp,langcode("WPUPSTI032"),humidex);
                  XmTextInsert(si_text,pos,temp);
                  pos=pos+strlen(temp);
		  }

                if(station_data[found].wx_baro_on == 1) 
                  {sprintf(temp,langcode("WPUPSTI033"),station_data[found].wx_baro);
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp);
                   sprintf(temp,"\n");
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp);  
		  }
                  else
                  {if(last_pos!=pos)
                     {sprintf(temp,"\n");
                      XmTextInsert(si_text,pos,temp);
                      pos=pos+strlen(temp);
		     }
		  }

                if(station_data[found].wx_snow_on == 1) 
                  {if(!units_english_metric)
                     {sprintf(temp,langcode("WPUPSTI034"),atof(station_data[found].wx_snow)*2.54);}
                     else
                     {sprintf(temp,langcode("WPUPSTI035"),station_data[found].wx_snow);}    
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp);
                   sprintf(temp,"\n");
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
                  }
                  
                if((station_data[found].wx_rain_on == 1) || (station_data[found].wx_prec_00_on == 1) || (station_data[found].wx_prec_24_on == 1))
                  {sprintf(temp,langcode("WPUPSTI036"));
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
		  }

                if(station_data[found].wx_rain_on == 1)
                  {if(!units_english_metric)
                     {sprintf(temp,langcode("WPUPSTI037"),atof(station_data[found].wx_rain)*.254);}
                     else
                     {sprintf(temp,langcode("WPUPSTI038"),station_data[found].wx_rain);}
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
		  }

                if(station_data[found].wx_prec_24_on == 1)
                  {if(!units_english_metric)
                     {sprintf(temp,langcode("WPUPSTI039"),atof(station_data[found].wx_prec_24)*.254);}
                     else
                     {sprintf(temp,langcode("WPUPSTI040"),station_data[found].wx_prec_24);}
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
		  }

                if(station_data[found].wx_prec_00_on == 1)
                  {if(!units_english_metric)
                     {sprintf(temp,langcode("WPUPSTI041"),atof(station_data[found].wx_prec_00)*.254);}
                     else
                     {sprintf(temp,langcode("WPUPSTI042"),station_data[found].wx_prec_00);}
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp);
		  }

                if(station_data[found].wx_rain_total_on == 1)
                  {sprintf(temp,"\n%s",langcode("WPUPSTI046"));
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
                   if(!units_english_metric)
                     {sprintf(temp,langcode("WPUPSTI047"),atof(station_data[found].wx_rain_total)*.254);}
                     else
                     {sprintf(temp,langcode("WPUPSTI048"),station_data[found].wx_rain_total);}
                   XmTextInsert(si_text,pos,temp);
                   pos=pos+strlen(temp); 
		  }
                sprintf(temp,"\n\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 

	       }

             sprintf(temp,langcode("WPUPSTI043"),station_data[found].node_path);
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp); 
             sprintf(temp,"\n");
             XmTextInsert(si_text,pos,temp);
             pos=pos+strlen(temp); 

             if(strlen(station_data[found].comments)>0)
               {sprintf(temp,langcode("WPUPSTI044"),station_data[found].comments);
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp);
                sprintf(temp,"\n");
                XmTextInsert(si_text,pos,temp);
                pos=pos+strlen(temp); 
	       }
	    }
	 }
      }

  XmTextShowPosition(si_text,0);
  button_cancel = XtVaCreateManagedWidget(langcode("UNIOP00003"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(si_text),
                                      XmNtopOffset,10, 
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 3,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 4,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);

  XtAddCallback(button_cancel, XmNactivateCallback, Station_data_destroy_shell, station_info);

  button_clear_track = XtVaCreateManagedWidget(langcode("WPUPSTI045"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(si_text),
                                      XmNtopOffset,10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 0,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 1,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);
  destroy_track_pointer = found;
  XtAddCallback(button_clear_track, XmNactivateCallback, Station_data_destroy_track ,NULL);

  button_message = XtVaCreateManagedWidget(langcode("WPUPSTI002"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(si_text),
                                      XmNtopOffset,10, 
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 1,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 2,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);

   XtAddCallback(button_message, XmNactivateCallback, Send_message_call ,(XtPointer)station_data[found].call_sign);

   if(fcc_data_available>=1 && strncmp(station,"V",1))
     {button_fcc = XtVaCreateManagedWidget(langcode("WPUPSTI003"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(si_text),
                                      XmNtopOffset,10, 
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 2,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 3,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);
      XtAddCallback(button_fcc, XmNactivateCallback, Station_data_add_fcc,(XtPointer)station_data[found].call_sign);
      }

   if(rac_data_available==1 && (!strncmp(station,"VE",2) || !strncmp(station,"VA",1))) 
     {button_rac = XtVaCreateManagedWidget(langcode("WPUPSTI004"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(si_text),
                                      XmNtopOffset,10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 2,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 3,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);
      XtAddCallback(button_rac, XmNactivateCallback, Station_data_add_rac,(XtPointer)station_data[found].call_sign);
     }
    

   pos_dialog(station_info);

   delw = XmInternAtom(XtDisplay(station_info),"WM_DELETE_WINDOW", False);
   XmAddWMProtocolCallback(station_info, delw, Station_data_destroy_shell, (XtPointer)station_info);

   XtManageChild(form);
   XtManageChild(si_text);
   XtManageChild(pane);

   XtPopup(station_info,XtGrabNone);

  }


}

/****** station popup info box *********/

void Station_info_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{
 Widget shell = (Widget) clientData;

 if(station_info!=NULL)
   {Station_data_destroy_shell(station_info, station_info, NULL);}

 XtPopdown(shell);
 XtDestroyWidget(shell);
 station_popup = (Widget)NULL;
}

void Station_info_select_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{ 
/* Widget shell = (Widget) clientData;*/
 int i,x;
 char *temp;
 char temp2[50];
 XmString *list;
 int found;

 found=0;

 if(station_popup)
   {XtVaGetValues(station_list,
               XmNitemCount,&i,
               XmNitems,&list,
               NULL);

    for(x=1; x<=i;x++)
       {if(XmListPosSelected(station_list,x))
          {found=1;
           if(XmStringGetLtoR(list[(x-1)],XmFONTLIST_DEFAULT_TAG,&temp))
             {x=i+1;}
	  }
       }
 
   if(found)
     {sprintf(temp2,"%s",temp);
      Station_data(widget,temp2,NULL);
     }

   }

/* XtDestroyWidget(shell);
 station_popup = (Widget)NULL;*/
}

void Station_info(Widget w, XtPointer clientData, XtPointer calldata)
{int data_ptr_i;
int found;
int num_found;
unsigned long min_diff,diff;

int n;
Atom delw;
static Widget  pane, form, button_ok, button_cancel;

num_found=0;
found=-1;
min_diff=32000000l;
for(data_ptr_i=0;data_ptr_i<stations;data_ptr_i++)
   {if(station_data[data_ptr_i].active == RECORD_ACTIVE)
       {diff=labs((x_long_offset+(menu_x*size))-station_data[data_ptr_i].long_pos)+labs((y_lat_offset+(menu_y*size))-station_data[data_ptr_i].lat_pos);
        if((diff/size)<min_diff)
          {min_diff=(diff/size);
           found=data_ptr_i;
           num_found=1;
	  }
          else
          {if((diff/size)<=(min_diff+2))
             {num_found++;}
	  }
       }
    }
if(found!=-1 && (min_diff<250))
  {if(num_found==1)
     {/*Station_data(w,station_data[found].call_sign,NULL);*/
/*      printf("\nStation %s\n",station_data[found].call_sign); 
      printf("Heard via %c last time %ld  moving %c packets heard %d\n",station_data[found].data_via,station_data[found].sec_heard,station_data[found].moving,station_data[found].num_packets);
      printf("Data path %s\n",station_data[found].node_path);
      printf("Comments %s\n",station_data[found].comments);*/
      Station_data(w,station_data[found].call_sign,NULL);
     }
     else
     {if(station_popup!=NULL)
        {Station_info_destroy_shell(station_popup, station_popup, NULL);}
     
      if(station_popup==NULL)
        {station_popup = XtVaCreatePopupShell(langcode("STCHO00001"),xmDialogShellWidgetClass,GetTopShell(w),
                                  XmNdeleteResponse,XmDESTROY,
                                  XmNdefaultPosition, False,
                                  NULL);

         pane = XtVaCreateWidget("pane",xmPanedWindowWidgetClass, station_popup,
                          XmNsashWidth, 1,
                          XmNsashHeight, 1,
                         NULL);


         form =  XtVaCreateWidget("form2",xmFormWidgetClass,pane,
                            XmNfractionBase, 5,
                            NULL);



         station_list = XmCreateScrolledList(form,"list",NULL,0);
         XtVaSetValues(station_list,
                XmNvisibleItemCount, 6,
                XmNtraversalOn, False,
                XmNshadowThickness, 3,
                XmNbackground, colors[0x0f],
                XmNselectionPolicy, XmSINGLE_SELECT,
                XmNscrollBarPlacement, XmBOTTOM_LEFT,
                NULL);


         /*printf("What station\n");*/
         n=1;
         for(data_ptr_i=0;data_ptr_i<stations;data_ptr_i++)
            {if(station_data[station_ptr[data_ptr_i]].active == RECORD_ACTIVE)
               {diff=labs((x_long_offset+(menu_x*size))-station_data[station_ptr[data_ptr_i]].long_pos)+labs((y_lat_offset+(menu_y*size))-station_data[station_ptr[data_ptr_i]].lat_pos);
                if((diff/size)<=(min_diff+2))
                  {/*printf("Station %s\n",station_data[station_ptr[data_ptr_i]].call_sign);*/
                   XmListAddItem(station_list,XmStringCreateLtoR(station_data[station_ptr[data_ptr_i]].call_sign,XmFONTLIST_DEFAULT_TAG),n++);
                  } 
	       }
	    }


         XtVaSetValues(XtParent(station_list),
                  XmNtopAttachment, XmATTACH_FORM,
                  XmNtopOffset, 5,
                  XmNbottomAttachment, XmATTACH_NONE,
                  XmNrightAttachment, XmATTACH_FORM,
                  XmNleftAttachment, XmATTACH_FORM,
                  NULL);


         button_ok = XtVaCreateManagedWidget("Info",xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(station_list),
                                      XmNtopOffset,10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 1,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 2,
                                      XmNshowAsDefault, True,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);

         button_cancel = XtVaCreateManagedWidget(langcode("UNIOP00003"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(station_list),
                                      XmNtopOffset,10, 
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 3,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 4,
                                      XmNdefaultButtonShadowThickness, 1,
                                      NULL);

         XtAddCallback(button_cancel, XmNactivateCallback, Station_info_destroy_shell, station_popup);
         XtAddCallback(button_ok, XmNactivateCallback, Station_info_select_destroy_shell, station_popup);

         pos_dialog(station_popup);

         delw = XmInternAtom(XtDisplay(station_popup),"WM_DELETE_WINDOW", False);
         XmAddWMProtocolCallback(station_popup, delw, Station_info_destroy_shell, (XtPointer)station_popup);

         XtManageChild(form);
         XtManageChild(station_list);
         XtManageChild(pane);

         XtPopup(station_popup,XtGrabNone);
	}
     }
  }
}


void mem_input_database(DataRow fill)
{
char station_num[30];
long record_start;
long record_end;
long record_mid;
int done;

fill.active=RECORD_ACTIVE;
if(!wait_to_redraw)
  {sprintf(station_num,langcode("BBARSTH001"),stations); 
   XmTextFieldSetString (text3, station_num);
  }

if(stations<MAX_STATIONS)
  {copy_data(&station_data[stations],&fill);
   station_ptr[stations]=stations; 
   if(stations>=1)
     {/* more than one record*/
     record_start=0l;
     record_end=(stations-1);
     record_mid=(record_end-record_start)/2; 
     done=0;
     while(!done)
          {/* get data for record start */
           if(strcmp(fill.call_sign,station_data[station_ptr[record_start]].call_sign)<0) 
             {/* file name comes before */
              done=1;
              /* now place pointer before start*/
              mem_reset_pointers(stations,stations,0,record_start); 
	     }
             else
             {/* get data for record end */  
              if(strcmp(fill.call_sign,station_data[station_ptr[record_end]].call_sign)>0)
                {/* file name comes after */
                 done=1;
                 /* pointer is at end */
		}
                else
                {if((record_mid==record_start) || (record_mid==record_end))
                   {/* no mid for compare check to see if in the middle */
                    done=1;
                    /* now place pointer before start*/
                    if(record_mid==record_start)
                      {mem_reset_pointers(stations,stations,0,record_mid+1);}
                      else 
                      {mem_reset_pointers(stations,stations,0,record_mid-1);}
		   }
                   else
                   {/* get data for record mid */
                    if(strcmp(fill.call_sign,station_data[station_ptr[record_mid]].call_sign)<0)
                      {/* checking  comes before */
                       /*record_start=0l;*/
                       record_end=record_mid;
                       record_mid=record_start+(record_end-record_start)/2; 
		      }
                      else
                      {/* ckecking come after*/
                       record_start=record_mid;
                       /*record_end=end*/
                       record_mid=record_start+(record_end-record_start)/2;
		      }
		   }
		}
	     }
	  }
     }
   stations++;
  }
}


int mem_find_data(DataRow fill)
{
int return_record;
int record_start;
int record_end;
int record_mid;
int done;

return_record=-1l;

if(stations<1)
  {if(strcmp(fill.call_sign,station_data[0].call_sign)==0)
      {return_record = 0l;}
  }
  else
  {/* more than one record*/
   record_start=0l;
   record_end=(stations-1);
   record_mid=(record_end-record_start)/2; 
   done=0;
   while(!done)
        {/* get data for record start */
         if(strcmp(fill.call_sign,station_data[station_ptr[record_start]].call_sign)<=0) 
           {if(strcmp(fill.call_sign,station_data[station_ptr[record_start]].call_sign)==0)
              {return_record = record_start;}
            /*name comes before */
            done=1;
	   }
           else
           {/* get data for record end */  
            if(strcmp(fill.call_sign,station_data[station_ptr[record_end]].call_sign)>=0)
              {if(strcmp(fill.call_sign,station_data[station_ptr[record_end]].call_sign)==0)
                 {return_record = record_end;}
               /*name comes after */
               done=1;
	      }
              else
              {if((record_mid==record_start) || (record_mid==record_end))
                 {/* no mid for compare check to see if in the middle */
                  done=1;
                  /* now place pointer before start*/
                  if(strcmp(fill.call_sign,station_data[station_ptr[record_mid]].call_sign)==0)
                    {return_record = record_mid;}
		 }
                 else
                 {/* get data for record mid */
                  if(strcmp(fill.call_sign,station_data[station_ptr[record_mid]].call_sign)<0)
                    {/* checking  comes before */
                     /*record_start=0l;*/
                     record_end=record_mid;
                     record_mid=record_start+(record_end-record_start)/2; 
		    }
                    else
                    {/* ckecking come after*/
                     record_start=record_mid;
                     /*record_end=end*/
                     record_mid=record_start+(record_end-record_start)/2;
		    }
		 }
	      }       
	   }
	}
  }
return(return_record);
}



void mem_replace_data(DataRow fill, int record_num)
{
copy_data(&station_data[station_ptr[record_num]],&fill);
}

void mem_get_data(DataRow *fill,int record_num)
{
 /* get data and check */
 copy_data(fill,&station_data[station_ptr[record_num]]);
}

int data_val(char *st, int len)
{char temp[12];

 if(len>10)
   {len=10;}
 strncpy(temp,st,len);
 temp[len]=0;
 return(atoi(temp));
}

int heard_via_tnc_in_past_hour(char *call)
{DataRow fill;
 int record;
 int found;
 int in_hour;

 in_hour=0;
 found=0;
 strcpy(fill.call_sign,call);
 record = mem_find_data(fill);
 if(record != -1l)
   {mem_get_data(&fill,record);
    if(debug_level & 2)    
      {printf("IG:Heard %s via %c\n",call,fill.heard_via_tnc);}
    if(fill.heard_via_tnc==VIA_TNC)
      {/* check to see if the last packet was message capable? */
       /* ok look to see if it is within the hour */
       in_hour = (fill.heard_via_tnc_last_time+3600l)>sec_now();
       if(debug_level & 2)
         {printf("Call %s: %ld %ld ok %d\n",call,fill.heard_via_tnc_last_time, sec_now(),in_hour);}
       found=1;
      }
      else
      {if(debug_level & 2)
         {printf("Call %s Not heard via tnc\n",call);}
      }
   }
   else
   {if(debug_level & 2)
      {printf("IG:station not found\n");}
   }
return(found);
}


void data_add(int type ,char *call_sign, char *path, char *data, char from, int port)
{DataRow fill, fill_old;
int mv;
int temp_dat;
int type_found;
int commentstart;

char *temp_ptr;

char temp_data[40];
char time_data[MAX_TIME];

char your_lat[MAX_LAT];
char your_long[MAX_LONG];

char lat_s[20];
char long_s[20];

/* MTG HACK */
double distance;
/* MTG HACK */

char station_id[600];
 
int record;
int call_len;

long x_long, y_lat;
long x_diff_long, y_diff_lat;

long x_origin, y_origin,x,y,max_x,max_y;

float lon_float;
float lat_float;
char x1,x2,x3,x4;
char y1,y2,y3,y4;
int lat_int;
int lon_int;       

char wx_tm[50];
char temp_long[20];
char temp_lat[20];
char temp_altitude[20];
char temp_course[20];
char temp_speed[20];
char temp_wx_temp[60];
char temp_wx_wind[60];
char temp_my_distance[20];
char temp_my_course[20];
char temp1_my_course[20];
time_t temp_sec_heard;
int iii;
int wx_strpos;
int wx_done;
int str_len;
int found_pos;
int temp_stp;
commentstart=0;
type_found=0;
/*printf("Path %s\n",path);*/

found_pos=0;
y_lat=0l;
x_long=0l;

strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);

if(call_sign[0]=='}')
    {strncpy(fill.call_sign,call_sign+1,(MAX_CALLSIGN-1));
     fill.pass_thru = TRUE;
    }
call_len=strlen(fill.call_sign);
if(fill.call_sign[(call_len-1)]=='*')
  {fill.call_sign[(call_len-1)]=0;}

if(is_call(fill.call_sign)==1)
  {
record = mem_find_data(fill);
if(record != -1l)
  {/* fill old data */
   mem_get_data(&fill,record);
   copy_data(&fill_old,&fill);
   /*printf("OLD DATA %s  PT %s POST %s\n",fill.call_sign,fill.packet_time,fill.pos_time);*/
  }
  else
  {clear_data(&fill);
   strcpy(long_s,"18000.00W");
   strcpy(lat_s,"9000.00N");
   fill.long_pos = x_long = convert_long_string(long_s);
   fill.lat_pos = y_lat = convert_lat_string(lat_s);
   }

/* see if we heard via tnc */
if(record != -1l)
  {if(from==DATA_VIA_TNC)
     {fill.heard_via_tnc=VIA_TNC;
      fill.heard_via_tnc_last_time=sec_now();
      fill.last_heard_via_tnc=0l;
      fill.heard_via_tnc_port=port;
     }
     else
     {fill.last_heard_via_tnc++;
      /* if the last 20 times this station was heard other than tnc clear the heard tnc data */
      if(fill.last_heard_via_tnc>20)
        {fill.last_heard_via_tnc=0l;
         if(fill.heard_via_tnc==VIA_TNC)
           {fill.heard_via_tnc=NOT_VIA_TNC;}
	}
     }
  }
  else
  {if(from!=DATA_VIA_TNC)
     {fill.heard_via_tnc=NOT_VIA_TNC;
      fill.last_heard_via_tnc=sec_now();
      fill.heard_via_tnc_last_time=0l;
     }
     else
     {fill.heard_via_tnc=VIA_TNC;
      fill.heard_via_tnc_last_time=sec_now();
      fill.last_heard_via_tnc=0l;
      fill.heard_via_tnc_port=port;
     }
   
  }

fill.sec_heard=sec_now();
fill.last_port_heard=port;

/*printf("DATA %s>%s:%s\n",call_sign,path,data);*/
switch(type)
      {case(APRS_MSGCAP):
       case(APRS_MSGCAP_COMPRESSED):
       case(APRS_FIXED_COMPRESSED):  
       case(APRS_FIXED) :type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = NORMAL_APRS;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.pos_time,get_time(time_data));

                         if(type == APRS_MSGCAP )
                           {fill.message_capable = 'Y';}
                           else
                           {fill.message_capable = 'N';}


                          /* If not compressed mode */
                         if( type == APRS_MSGCAP || type == APRS_FIXED )
			   {if(data[9] != '/' && data[9] !='\\')
                              {/* Symbol overlay */
                               fill.aprs_symbol.aprs_type = '\\';
                               fill.aprs_symbol.special_overlay = data[9];
			      }
                              else
                              {fill.aprs_symbol.aprs_type = data[9];
                               fill.aprs_symbol.special_overlay=' ';
			      }
                            fill.aprs_symbol.aprs_symbol = data[19];
                            strncpy(fill.long_pos_x,data+10,8);
                            fill.long_ew = data[18];
                            strncpy(fill.lat_pos_y,data+1,7);
                            fill.lat_ns = data[8];
                            found_pos=1;

                            commentstart=20;
                        
                            if(strlen(data)>23)
                              {if(look_for_powergain_in_comments(data+20))
                                 {commentstart=28;
                                  strncpy(fill.power_gain,data+20,7);
				 }
                                 else
                                 {if(look_for_omnidf_in_comments(data+20))
                                    {commentstart=28;
                                     strncpy(fill.power_gain,data+20,7);
				    }
				 }
			      }
			   }
                           else
                           {/* Compressed mode, YYYYXXXX format Lat/Lon */
                            if(data[1] != '/' && data[1] !='\\')
                              {/* Symbol overlay */
                               fill.aprs_symbol.aprs_type = '\\';
                               fill.aprs_symbol.special_overlay = data[1];
			      }
	                      else
		              {fill.aprs_symbol.aprs_type = data[1];
			       fill.aprs_symbol.special_overlay=' ';
			      }
		            fill.aprs_symbol.aprs_symbol = data[10];



                            /*********************************************
			      Need to handle the lat/lon differently here,
                              as it is in a compressed format
                             *********************************************/

                            y1 = data[2];
                            y2 = data[3];
			    y3 = data[4];
		            y4 = data[5];
			    x1 = data[6];
	                    x2 = data[7];	 
                            x3 = data[8];
	                    x4 = data[9];

                            if(debug_level & 1)
                              {printf("decode c:%s p:%s d:%s f:%c\n",call_sign,path,data,from);}

			  
			    /* This will give decimal degrees for each.  W=-, E=+, N=+, S=- */
			    lat_float = 90.0 - ( ( (y1-33.0)*(91.0 * 91.0 * 91.0)
				             + (y2-33.0)*(91.0 * 91.0)
		                             + (y3-33.0)*91.0
					     + (y4-33.0) ) / 380926.0 );

                            lon_float = -180.0 + ( ( (x1-33.0)*(91.0 * 91.0 * 91.0)
                                               + (x2-33.0)*(91.0 * 91.0)
                                               + (x3-33.0)*91.0
                                               + (x4-33.0) ) / 190463.0 );


                            if(debug_level & 1)
			      {printf("%f\t%f\n",lat_float,lon_float);}


		            /* Check for N/S and set variables appropriately */
                            if (lat_float >= 0.0)
	                       {fill.lat_ns = 'N';}
                               else
			       {fill.lat_ns = 'S';
				lat_float = -lat_float;     /* Make it positive */
			       }

                            /* Check for E/W and set variables appropriately */
                            if (lon_float >= 0.0)
			       {fill.long_ew = 'E';}
			       else
                               {fill.long_ew = 'W';
                                lon_float = -lon_float;     /* Make it positive */
			       }


                           /* May need to convert to the DDMM.MMMM format for each, then to ASCII
                              then stuff it in the variables. */

			   /* This is kind of backwards, because we stuff the strings here, and
			      then this routine computes the long integer from the string later. */

	                   /* We'll do the integer portion first, then multiply by 60 to create the
                              minutes portion of the string and fill in the rest. */
			   /* DDDMM.MM */

	                   /* Print out the degrees */
                           lon_int = (int)lon_float;
                           sprintf(temp_long,"%.3d",lon_int);

															
	                   if(debug_level & 1)
	                     {printf("%.3d",lon_int);}

                           strncpy(fill.long_pos_x,(char *)&temp_long,3);
                           /* Print mm.mm portion */
			   if ( ( (lon_float - (int)lon_float) * 60 ) < 10.0 )
                             {sprintf(temp_long,"0%.2f",(lon_float - (int)lon_float) * 60);
			      if(debug_level & 1)
                                {printf("0%.2f\t\t",(lon_float - (int)lon_float) * 60);}
			     }
                             else
                             {sprintf(temp_long,"%.2f",(lon_float - (int)lon_float) * 60);
                              if(debug_level & 1)
                                {printf("%.2f\t\t",(lon_float - (int)lon_float) * 60);}
			     }

                           strncpy(&fill.long_pos_x[3],(char *)&temp_long,5);

                           /* DDMM.MM */
                           /* Print out the degrees */
                           lat_int = (int)lat_float;
                           sprintf(temp_lat,"%.2d",lat_int);

                           if(debug_level & 1)
                             {printf("%.2d",lat_int);}

                            strncpy(fill.lat_pos_y,(char *)&temp_lat,2);
			    /* Print mm.mm portion */
                            if ( ( (lat_float - (int)lat_float)*60 ) < 10.0 )
			       {if(debug_level & 1)
                                  {printf("0%.2f\n",(lat_float - (int)lat_float)*60);}
			       }
                               else
                               {sprintf(temp_lat,"%.2f",(lat_float - (int)lat_float)*60);
                                if(debug_level & 1)
                                  {printf("%.2f\n",(lat_float - (int)lat_float)*60);}
			       }

                             strncpy(&fill.lat_pos_y[2],(char *)&temp_lat,5);

                             /* NOTE: Not sure if this makes sense since we have  */
                             /* specified characters in the transmission          */

                             /* Now what about decoding the CsT characters?       */
                             /* Look at the RMC and GGA string parsing for clues. */
                             /* fill.aprs_symbol = *id_callsign(call_sign, path); */

                             found_pos=1;
    
                             commentstart=14;
			     if(strlen(data)>17)
			       {if(look_for_powergain_in_comments(data+14))
                                  {commentstart=22;
	                           strncpy(fill.power_gain,data+14,7); 
                                  }
                                  else
                                  {if(look_for_omnidf_in_comments(data+14))
				    {commentstart=22;
	                             strncpy(fill.power_gain,data+14,7);
				    }
				  }

			       }

			   /*if(strlen(fill.power_gain)>3)
                              {printf("Pg:<%s>\n",fill.power_gain);}
                            */

			   }

                         if(strlen(data)>commentstart) 
                           {strncpy(fill.comments,data+commentstart,MAX_COMMENTS);}
    
                        break;

       case(APRS_OBJECT) :type_found=APRS_OBJECT;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = NORMAL_APRS;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.pos_time,get_time(time_data));
                         fill.message_capable = 'N';
                         
                         if(data[15] != '/' && data[15] !='\\')
                           {/* Symbol overlay */
                            fill.aprs_symbol.aprs_type = '\\';
                            fill.aprs_symbol.special_overlay = data[15];
                           }
                           else
                           {fill.aprs_symbol.aprs_type = data[15];
                            fill.aprs_symbol.special_overlay=' ';
                           }
                         fill.aprs_symbol.aprs_symbol = data[25];
                         strncpy(fill.long_pos_x,data+16,8);
                         fill.long_ew = data[24];
                         strncpy(fill.lat_pos_y,data+7,7);
                         fill.lat_ns = data[14];
                         found_pos=1;

                         commentstart=34;
                         if(strlen(data)>commentstart)
                           {strncpy(fill.comments,data+commentstart,MAX_COMMENTS);}
                            
                        break;

        case(APRS_DOWN_COMPRESSED):
        case(APRS_DOWN):type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = DOWN_APRS;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.pos_time,get_time(time_data));
                         fill.message_capable = 'N';

                         /* If not compressed mode */
			 if( type == APRS_DOWN )
	                   {fill.aprs_symbol.aprs_type = data[16];
                            fill.aprs_symbol.aprs_symbol = data[26];
                            strncpy(fill.long_pos_x,data+17,8);
                            fill.long_ew = data[25];
                            strncpy(fill.lat_pos_y,data+8,7);
                            fill.lat_ns = data[15];
                            strncpy(fill.station_time,data+1,6);
                            fill.station_time_type = data[7];
                            found_pos=1;

                            commentstart=27;
                            if(strlen(data)>30)
                              {if(look_for_powergain_in_comments(data+27))
                                 {commentstart=35;
                                  strncpy(fill.power_gain,data+27,7);
			         }
                                 else
                                 {if(look_for_omnidf_in_comments(data+27))
                                    {commentstart=35;
                                     strncpy(fill.power_gain,data+27,7);
				    }
				 }
			      }
			   }
                           else
                           {/* compressed mode */
                            fill.aprs_symbol.aprs_type = data[8];
                            fill.aprs_symbol.special_overlay = data[17];

                            /*********************************************
                             Need to handle the lat/lon differently here,
			     as it is in a compressed format
                             *********************************************/

                            y1 = data[9];
			    y2 = data[10];
                            y3 = data[11];
                            y4 = data[12];
	                    x1 = data[13];
                            x2 = data[14];
                            x3 = data[15];
                            x4 = data[16];      

                            if(debug_level & 1)
                              {printf("decode c:%s p:%s d:%s f:%c\n",call_sign,path,data,from);}

                            /* This will give decimal degrees for each.  W=-, E=+, N=+, S=- */
                            lat_float = 90.0 - ( ( (y1-33.0)*(91.0 * 91.0 * 91.0)
                                             + (y2-33.0)*(91.0 * 91.0)
                                             + (y3-33.0)*91.0
                                             + (y4-33.0) ) / 380926.0 );

                            lon_float = -180.0 + ( ( (x1-33.0)*(91.0 * 91.0 * 91.0)
                                               + (x2-33.0)*(91.0 * 91.0)
                                               + (x3-33.0)*91.0
                                               + (x4-33.0) ) / 190463.0 );

                            if(debug_level & 1)
			      {printf("%f\t%f\n",lat_float,lon_float);}


                             /* Check for N/S and set variables appropriately */
                             if(lat_float >= 0.0)
                               {fill.lat_ns = 'N';}
                               else
                               {fill.lat_ns = 'S';
			        lat_float = -lat_float;     /* Make it positive */
			       }

                             /* Check for E/W and set variables appropriately */
                             if(lon_float >= 0.0)
                               {fill.long_ew = 'E';}
                               else
                               {fill.long_ew = 'W';
			        lon_float = -lon_float;     /* Make it positive */
			       }

                             /* May need to convert to the DDMM.MMMM format for each, then to ASCII,
                               then stuff it in the variables. */ 


                             /* This is kind of backwards, because we stuff the strings here, and
                                then this routine computes the long integer from the string later. */

                             /* We'll do the integer portion first, then multiply by 60 to create the
                                minutes portion of the string and fill in the rest. */ 

                             /* DDDMM.MM */
                             /* Print out the degrees */
                             lon_int = (int)lon_float;
			     sprintf(temp_long,"%.3d",lon_int);

                             if(debug_level & 1)
                               {printf("%.3d",lon_int);}

                             strncpy(fill.long_pos_x,(char *)&temp_long,3);
                             /* Print mm.mm portion */
			     if( ( (lon_float - (int)lon_float) * 60 ) < 10.0 )
                               {sprintf(temp_long,"0%.2f",(lon_float - (int)lon_float) * 60);
			        if(debug_level & 1)
                                  {printf("0%.2f\t\t",(lon_float - (int)lon_float) * 60);}
			       }
                               else
                               {sprintf(temp_long,"%.2f",(lon_float - (int)lon_float) * 60);
			        if(debug_level & 1)
                                  {printf("%.2f\t\t",(lon_float - (int)lon_float) * 60);}
			       }
 
                             strncpy(&fill.long_pos_x[3],(char *)&temp_long,5);

                             /* DDMM.MM */
			     /* Print out the degrees */
                             lat_int = (int)lat_float;
	                     sprintf(temp_lat,"%.2d",lat_int);
                             if(debug_level & 1)
                               {printf("%.2d",lat_int);}

                             strncpy(fill.lat_pos_y,(char *)&temp_lat,2);
                             /* Print mm.mm portion */
                             if( ( (lat_float - (int)lat_float)*60 ) < 10.0 )
                               {sprintf(temp_lat,"0%.2f",(lat_float - (int)lat_float)*60);
			        if(debug_level & 1)
                                  {printf("0%.2f\n",(lat_float - (int)lat_float)*60);}
			       }
                               else
                               {sprintf(temp_lat,"%.2f",(lat_float - (int)lat_float)*60);
                                if(debug_level & 1)
                                  {printf("%.2f\n",(lat_float - (int)lat_float)*60);}
			       }

                             strncpy(&fill.lat_pos_y[2],(char *)&temp_lat,5);

                             /* NOTE: Not sure if this makes sense since we have  */
                             /* specified characters in the transmission          */
 
			     /* Now what about decoding the CsT characters?       */
                             /* Look at the RMC and GGA string parsing for clues. */
                             /* fill.aprs_symbol = *id_callsign(call_sign, path); */

                             strncpy(fill.station_time,data+1,6);  /* Still ok */
			     fill.station_time_type = data[7];     /* Still ok */
			     found_pos=1;

                             commentstart=21;
                             if(strlen(data)>24)
			       {if(look_for_powergain_in_comments(data+21))
			          {commentstart=29;
			           strncpy(fill.power_gain,data+21,7);
				  }
		                  else
                                  {if(look_for_omnidf_in_comments(data+21))
				     {commentstart=29;
                                      strncpy(fill.power_gain,data+21,7);
				     }
				  }
			       }
			   }
                         
                         if(strlen(data)>commentstart)
			   {strncpy(fill.comments,data+commentstart,MAX_COMMENTS);}
			   
                        break;

        case(APRS_MOBILE):
        case(APRS_DF):   type_found=1;
                         fill.active = RECORD_ACTIVE;
                         if(type == APRS_MOBILE)
                           {fill.record_type = MOBILE_APRS;}
                           else
                           {fill.record_type = DF_APRS;}
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         fill.message_capable = 'N';
                         fill.aprs_symbol.aprs_type = data[16];
                         fill.aprs_symbol.aprs_symbol = data[26];
                         strncpy(fill.long_pos_x,data+17,8);
                         fill.long_ew = data[25];
                         strncpy(fill.lat_pos_y,data+8,7);
                         fill.lat_ns = data[15];
                         strncpy(fill.station_time,data+1,6);
                         fill.station_time_type = data[7];
                         found_pos=1;

                         if(type == APRS_MOBILE)
                           {/* get aprs mobile data */
                            if(data[30]=='/' && is_num_stuff(data+27,3) && is_num_stuff(data+31,3))
                              {/*sprintf(fill.speed,"",MAX_SPEED);*/
                               fill.speed_unit='K';
                               /* miles/hr to knots*/
                               sprintf(fill.speed,"%06.2f",(float)(data_val(data+31,3)*0.86897));
                               strncpy(fill.course,data+27,MAX_COURSE);
                               fill.course[3]=0;
                               /*printf("%s Course %s speed %s\n",fill.call_sign,fill.course,fill.speed);*/
			      }
     			   }
                           else
                           {/* get aprs df data */

			   }
                         commentstart=35;
                        
                         if(look_for_powergain_in_comments(data+commentstart))
                           {strncpy(fill.power_gain,data+commentstart,7);
                            commentstart=43;
			   }
                           else
                           {temp_stp=look_for_altitude_in_comments(data+commentstart);
                            if(temp_stp>0)
                              {commentstart=35+temp_stp;
                               /* feet to meters */
                               sprintf(fill.altitude,"%.2f",(float)(data_val(data+commentstart,6)*0.3048)); 
                               fill.alt_unit='M';
                               if(debug_level & 1)
                                 {printf("%s ALTITUDE %s %s\n",fill.call_sign,data+commentstart,fill.altitude);}          
                               commentstart=35+temp_stp+6;
			      }
                              else
                              {if(look_for_omnidf_in_comments(data+commentstart))
                                 {strncpy(fill.power_gain,data+commentstart,7);
                                  commentstart=43;
				 }
			      }
			   }
                                              
                         strncpy(fill.comments,data+commentstart,MAX_COMMENTS);
                        break;

        case(APRS_WX1):  type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = APRS_WX1;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.wx_time,get_time(time_data));
                         fill.wx_sec_time=sec_now();
                         fill.wx_data=1;
                         fill.aprs_symbol.aprs_type = data[16];
                         fill.aprs_symbol.aprs_symbol = data[26];
                         strncpy(fill.long_pos_x,data+17,8);
                         fill.long_ew = data[25];
                         strncpy(fill.lat_pos_y,data+8,7);
                         fill.lat_ns = data[15];
                         found_pos=1;
                         strncpy(fill.station_time,data+1,6);
                         fill.station_time_type = data[7];
                         /*printf("APRS WX1 %s, %s\n",fill.call_sign,data+27);*/
                         fill.wx_course_on=1;
                         sprintf(fill.wx_course,"%03d",data_val(data+27,3));
                         if(data[30]=='/')
                           {sprintf(fill.wx_speed,"%03d",data_val(data+31,3));}
                           else
                           {strcpy(fill.wx_speed,"000");}
                         fill.wx_speed_on=1;
                         fill.wx_speed[3]=0;

                         fill.wx_gust_on=1;
                         if(data[34]=='g')
                           {sprintf(fill.wx_gust,"%03d",data_val(data+35,3));}
                           else
                           {strcpy(fill.wx_gust,"000");}
                         fill.wx_gust[3]=0;

                         fill.wx_temp_on=1;  
                         if(data[38]=='t')
                           {sprintf(fill.wx_temp,"%03d",data_val(data+39,3));}
                           else
                           {strcpy(fill.wx_temp,"000");}
                         fill.wx_temp[3]=0;
                         /* not sure what I'll get here */ 

                         wx_strpos=42;
                         wx_done=0;
                         str_len=strlen(data);
                         while(!wx_done && (wx_strpos<str_len))
                              {/*printf("STR %d %d\n",str_len,wx_strpos);*/
                               switch(data[wx_strpos])
                                     {case('.'):/* skip */
                                                wx_strpos+=4;   
                                                break;

                                      case('r'):/* rain */
                                                fill.wx_rain_on=1;
                                                sprintf(fill.wx_rain,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;   
                                                break;

                                      case('s'):/* snow */
                                                fill.wx_snow_on=1;
                                                sprintf(fill.wx_snow,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;
                                                break;

                                      case('p'):/* precip in floating 24 hr period */
                                                fill.wx_prec_24_on=1;
                                                sprintf(fill.wx_prec_24,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;
                                                break;

                                      case('P'):/* precip since midnight */
                                                fill.wx_prec_00_on=1;
                                                sprintf(fill.wx_prec_00,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;
                                                break;

                                      case('h'):/* Humiditiy*/
                                                fill.wx_hum_on=1;
                                                temp_dat=data_val(data+wx_strpos+1,2);
                                                if(data[55]=='0' && data[56]=='0')
                                                  {temp_dat=100;}
                                                sprintf(fill.wx_hum,"%03d",temp_dat);
                                                wx_strpos+=3;
                                                break;

                                      case('b'):/* Baro */
                                                fill.wx_baro_on=1;
                                                sprintf(fill.wx_baro,"%0.1f",((float)data_val(data+wx_strpos+1,5)/10.0));
                                                wx_strpos+=6;
                                                break;

                                      default:wx_done=1;
                                              fill.wx_type=data[wx_strpos];
                                              if(strlen(data)>wx_strpos+1)
                                                {strncpy(fill.wx_station,data+wx_strpos+1,MAX_WXSTATION);}
                                              break;
				     }
			      }
                        break;
        case(APRS_WX2):  type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = APRS_WX2;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.wx_time,get_time(time_data));
                         fill.wx_sec_time=sec_now();
                         fill.wx_data=1;
                         /*printf("APRS WX2 %s, cse:%d speed:%d %s\n",fill.call_sign,data_val(data+10,3),data_val(data+14,3),data);*/
                         if(data[9]=='c')
                           {sprintf(fill.wx_course,"%03d",data_val(data+10,3));}
                           else
                           {strcpy(fill.wx_course,"000");}
                         fill.wx_course_on=1;
                         fill.wx_course[3]=0;
                         
                         if(data[13]=='s')
                           {sprintf(fill.wx_speed,"%03d",data_val(data+14,3));}
                           else
                           {strcpy(fill.wx_speed,"000");}
                         fill.wx_speed_on=1;
                         fill.wx_speed[3]=0;

                         wx_strpos=17;
                         wx_done=0;
                         str_len=strlen(data);
                         while(!wx_done && (wx_strpos<str_len))
                              {/*printf("STR %d %d\n",str_len,wx_strpos);*/
                               switch(data[wx_strpos])
                                     {case('.'):/* skip */
                                                wx_strpos+=4;   
                                                break;

                                      case('g'):/* gust */
                                                fill.wx_gust_on=1;
                                                sprintf(fill.wx_gust,"%03d",data_val(data+wx_strpos+1,3));
                                                wx_strpos+=4;   
                                                break;

                                      case('t'):/* temp */
                                                fill.wx_temp_on=1;
                                                sprintf(fill.wx_temp,"%03d",data_val(data+wx_strpos+1,3));
                                                wx_strpos+=4;   
                                                break;

                                      case('r'):/* rain */
                                                fill.wx_rain_on=1;
                                                sprintf(fill.wx_rain,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;   
                                                break;

                                      case('s'):/* snow */
                                                fill.wx_snow_on=1;
                                                sprintf(fill.wx_snow,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;
                                                break;

                                      case('p'):/* precip in floating 24 hr period */
                                                fill.wx_prec_24_on=1;
                                                sprintf(fill.wx_prec_24,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;
                                                break;

                                      case('P'):/* precip since midnight */
                                                fill.wx_prec_00_on=1;
                                                sprintf(fill.wx_prec_00,"%0.2f",((float)data_val(data+wx_strpos+1,3)/100.0));
                                                wx_strpos+=4;
                                                break;

                                      case('h'):/* Humitiy*/
                                                fill.wx_hum_on=1;
                                                temp_dat=data_val(data+wx_strpos+1,2);
                                                if(data[55]=='0' && data[56]=='0')
                                                  {temp_dat=100;}
                                                sprintf(fill.wx_hum,"%03d",temp_dat);
                                                wx_strpos+=3;
                                                break;

                                      case('b'):/* Baro */
                                                fill.wx_baro_on=1;
                                                sprintf(fill.wx_baro,"%0.1f",((float)data_val(data+wx_strpos+1,5)/10.0));
                                                wx_strpos+=6;
                                                break;

                                      default:wx_done=1;
                                              fill.wx_type=data[wx_strpos];
                                              if(strlen(data)>wx_strpos+1)
                                                {strncpy(fill.wx_station,data+wx_strpos+1,MAX_WXSTATION);}
                                              break;
				     }
			      }
                        break;

        case(APRS_WX3):  
        case(APRS_WX4):  
        case(APRS_WX5):  type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = type;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.wx_time,get_time(time_data));
                         fill.wx_sec_time=sec_now();
                         fill.wx_data=1;

                         wx_fill_data(1,type,data,&fill);

                         break;

        case(GPS_RMC):   type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = NORMAL_GPS_RMC;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.pos_time,get_time(time_data));
                         fill.message_capable = 'N';
                         /* check aprs type on call sign */   
                         fill.aprs_symbol = *id_callsign(call_sign, path);
                         if(strchr(data,',')!=NULL)                                     
                           {strtok(data,",");						/* get gprmc */
                            strtok(NULL,",");     				        /* get temp */
                            temp_ptr=strtok(NULL,",");					/* get temp */
                            if(temp_ptr!=NULL)
                              {strncpy(temp_data,temp_ptr,2);
                               if(temp_data[0]=='A' || temp_data[0]=='V') /* V is a warning but we can get good data still ? */
                                 {temp_ptr=strtok(NULL,",");				/* get latitude */
                                  if(temp_ptr!=NULL && temp_ptr[4]=='.')
                                    {strncpy(fill.lat_pos_y,temp_ptr,7);
                                     temp_ptr=strtok(NULL,",");				/* get N-S */
                                     if(temp_ptr!=NULL)
                                       {strncpy(temp_data,temp_ptr,1);
                                        fill.lat_ns=toupper(temp_data[0]);
                                        if(fill.lat_ns =='N' || fill.lat_ns =='S') 
                                          {temp_ptr=strtok(NULL,",");			/* get long */
                                           if(temp_ptr!=NULL && temp_ptr[5] == '.')
                                             {strncpy(fill.long_pos_x,temp_ptr,8);
                                              temp_ptr=strtok(NULL,",");			/* get E-W */
                                              if(temp_ptr!=NULL)
                                                {strncpy(temp_data,temp_ptr,1);
                                                 fill.long_ew=toupper(temp_data[0]);
                                                 if(fill.long_ew =='E' || fill.long_ew =='W') 
                                                   {found_pos=1;
                                                    temp_ptr=strtok(NULL,",");		/* Get speed */
                                                    if(temp_ptr!=0)
                                                      {strncpy(fill.speed,temp_ptr,MAX_SPEED);
                                                       fill.speed_unit='K';
                                                       temp_ptr=strtok(NULL,",");	/* Get course */
                                                       if(temp_ptr!=NULL)
                                                         {strncpy(fill.course,temp_ptr,MAX_COURSE);
                                                          strtok(NULL,",");					/* get date of fix */
							 }
                                                         else
                                                         {strcpy(fill.course,"000.0");}
						      }
                                                      else
                                                      {strcpy(fill.speed,"0");}
						   }
                                                   else
                                                   {type_found=0;}
						}
                                                else
                                                {type_found=0;}
					     }
                                             else
                                             {type_found=0;}
					  }
                                          else
                                          {type_found=0;}
				       }
                                       else
                                       {type_found=0;}
				    }
                                    else
                                    {type_found=0;}
				 }
                                 else
                                 {type_found=0;}
			      }
                              else
                              {type_found=0;}
			   }
                           else
                           {type_found=0;}
                        break;

         case(GPS_GGA): type_found=1;
                        fill.active = RECORD_ACTIVE;
                        fill.record_type = NORMAL_GPS_GGA;
                        strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                        strncpy(fill.node_path,path,MAX_PATH);
                        strcpy(fill.packet_time,get_time(time_data));
                        strcpy(fill.pos_time,get_time(time_data));
                        strcpy(fill.altitude_time,get_time(time_data));
                        fill.message_capable = 'N';
                        /* check aprs type on call sign */
                        fill.aprs_symbol = *id_callsign(call_sign, path);
                        if(strchr(data,',')!=NULL)
                          {if(strtok(data,",")!=NULL) /* get gpgga*/
                             {if(strtok(NULL,",")!=NULL) /* get time */
                                {temp_ptr = strtok(NULL,",");                 /* get latitude */
                                 if(temp_ptr !=NULL)
                                   {strncpy(fill.lat_pos_y,temp_ptr,7);
                                    temp_ptr = strtok(NULL,",");                       /* get N-S */                 
                                    if(temp_ptr!=NULL)
                                      {strncpy(temp_data,temp_ptr,1);
                                       fill.lat_ns=toupper(temp_data[0]);
                                       if(fill.lat_ns == 'N' || fill.lat_ns == 'S')
                                         {temp_ptr = strtok(NULL,",");             /* get long */
                                          if(temp_ptr!=NULL)
                                            {strncpy(fill.long_pos_x,temp_ptr,8);
                                             temp_ptr = strtok(NULL,",");                   /* get E-W */
                                             if(temp_ptr!=NULL)
                                               {strncpy(temp_data,temp_ptr,1);       
                                                fill.long_ew=toupper(temp_data[0]);
                                                if(fill.long_ew == 'E' || fill.long_ew == 'W') 
                                                  {temp_ptr = strtok(NULL,",");                   /* get FIX Quality */
                                                   if(temp_ptr!=NULL)
                                                     {found_pos=1;
                                                      strncpy(temp_data,temp_ptr,2);
                                                      if(temp_data[0]=='1' || temp_data[0] =='2' ) 
                                                        {temp_ptr=strtok(NULL,",");  /* Get sats vis */
                                                         if(temp_ptr!=NULL)
                                                           {strncpy(fill.sats_visible,temp_ptr,MAX_SAT);  
                                                            temp_ptr=strtok(NULL,",");                                 /* get hoz dil */
                                                            if(temp_ptr!=NULL)
                                                              {temp_ptr=strtok(NULL,","); /* Get altitude */
                                                               if(temp_ptr!=NULL)
                                                                 {strcpy(fill.altitude,temp_ptr); /* Get altitude */
                                                                  temp_ptr=strtok(NULL,",");                /* get UNIT */
                                                                  if(temp_ptr!=NULL)
                                                                    {strncpy(temp_data,temp_ptr,1);                /* get UNIT */
                                                                     fill.alt_unit=temp_data[0];
								    }
                                                                    else
                                                                   {fill.alt_unit='M';}
								 }
                                                                 else
							         {strcpy(fill.altitude,"");}
							      }
                                                              else
                                                              {strcpy(fill.altitude,"");
                                                               fill.alt_unit=' ';  
							      }
							   }
                                                           else
                                                           {type_found=0;}
							}
                                                        else
                                                        {type_found=0;}
						     }
                                                     else
                                                     {type_found=0;}
						  }
                                                 else
                                                 {type_found=0;}
					       }
                                              else
                                              {type_found=0;}
					    }
				            else
                                            {type_found=0;}
					 }
                                         else
                                         {type_found=0;}
				      }
                                      else
                                      {type_found=0;}
				   }
                                   else
                                   {type_found=0;}
				}
                                else
                                {type_found=0;}
			     }
                             else
                             {type_found=0;}
			  }
                          else
                          {type_found=0;}
                        break;

        case(GPS_GLL):   type_found=1;
                         fill.active = RECORD_ACTIVE;
                         fill.record_type = NORMAL_GPS_GLL;
                         strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
                         strncpy(fill.node_path,path,MAX_PATH);
                         strcpy(fill.packet_time,get_time(time_data));
                         strcpy(fill.pos_time,get_time(time_data));
                         fill.message_capable = 'N';
                         /* check aprs type on call sign */   
                         fill.aprs_symbol = *id_callsign(call_sign, path);
                         if(strchr(data,',')!=NULL)                                     
			  {strtok(data,",");					/* get gpgll */
			   temp_ptr=strtok(NULL,",");				/* get latitude */
			   if(temp_ptr!=NULL && temp_ptr[4]=='.')
			    {strncpy(fill.lat_pos_y,temp_ptr,7);
			    temp_ptr=strtok(NULL,",");				/* get N-S */
			    if(temp_ptr!=NULL)
			     {strncpy(temp_data,temp_ptr,1);
			     fill.lat_ns=toupper(temp_data[0]);
			     if(fill.lat_ns =='N' || fill.lat_ns =='S') 
			      {temp_ptr=strtok(NULL,",");			/* get long */
			      if(temp_ptr!=NULL && temp_ptr[5] == '.')
			       {strncpy(fill.long_pos_x,temp_ptr,8);
			       temp_ptr=strtok(NULL,",");			/* get E-W */
			       if(temp_ptr!=NULL)
			        {strncpy(temp_data,temp_ptr,1);
				fill.long_ew=toupper(temp_data[0]);
				if(fill.long_ew =='E' || fill.long_ew =='W') 
				 {found_pos=1;
				 strtok(NULL,",");				/* get temp */
				 temp_ptr=strtok(NULL,",");			/* get temp */
				 if(temp_ptr!=NULL)
				  {strncpy(temp_data,temp_ptr,2);
				  if(temp_data[0]=='A' || temp_data[0]=='V') /* V is a warning but we can get good data still ? */
				  strcpy(fill.course,"000.0");
				  strcpy(fill.speed,"0");
				  }
				 else
				  {type_found=0;}
				 }
				else
				 {type_found=0;}
				}
			       else
			        {type_found=0;}
			       }
			      else
			       {type_found=0;}
			      }
			     else
			      {type_found=0;}
			     }
			    else
			     {type_found=0;}
			    }
			   else
			    {type_found=0;}
			  }
			 else
			  {type_found=0;}
			 break;

       default:printf("UNKNOWN TYPE in data_add\n");
               break; 
      }


if(type_found)
 {/* FROM */
  fill.data_via=from;
  fill.moving=0;
  if(found_pos)
    {sprintf(long_s,"%s%c",fill.long_pos_x,fill.long_ew);
     sprintf(lat_s,"%s%c",fill.lat_pos_y,fill.lat_ns);
     fill.long_pos = x_long = convert_long_string(long_s);
     fill.lat_pos = y_lat = convert_lat_string(lat_s);
    }


  /* Check Audio Alarms based on incoming packet */

  /* FG don't care if this is on screen or off get position */
  sprintf(temp_long,"%s%c",fill.long_pos_x,fill.long_ew);
  sprintf(temp_lat,"%s%c",fill.lat_pos_y,fill.lat_ns);
   
  if(units_english_metric)
    {distance = distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.15078;}
    else
    {distance = distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.852;}

  if (strcmp(fill.call_sign,my_callsign)!=0){
   /* check ranges */
   if((distance > atof(prox_min)) && (distance < atof(prox_max)) && sound_play_prox_message)
     {  
      sprintf(station_id,"%s < %.3f %s",fill.call_sign, distance, units_english_metric?langcode("UNIOP00004"):langcode("UNIOP00005"));
      XmTextFieldSetString (text, station_id);
      play_sound(sound_command,sound_prox_message);
      /*printf("%s> PROX distance %f\n",fill.call_sign, distance);*/
     }

   /* FG really should check the path before we do this and add setup for these ranges */ 
   if((distance > atof(bando_min)) && (distance < atof(bando_max)) && sound_play_band_open_message && from==DATA_VIA_TNC)
     {
      sprintf(station_id,"%s %s %.1f %s",fill.call_sign, langcode("UMBNDO0001"),distance, units_english_metric?langcode("UNIOP00004"):langcode("UNIOP00005"));
      XmTextFieldSetString (text, station_id);
      play_sound(sound_command,sound_band_open_message);
      /*printf("%s> BO distance %f\n",fill.call_sign, distance);*/
     }
  }

  /* check if new or old */
  if(record != -1l)
    {/* old record check if moving */
     if(fill_old.lat_pos!=fill.lat_pos)
       {/*printf("Station %s move lat\n",fill.call_sign);*/
        fill.moving=1;
       }
       else
       {if(fill_old.long_pos!=fill.long_pos)
          {/*printf("Station %s move long\n",fill.call_sign);*/
           fill.moving=1;
	  }
          /*else
          {fill.moving=0;}*/
       }

     if(fill.moving==1)
       {/*printf("x %s %ld\n",long_s,x_long);
        printf("y %s %ld\n",lat_s,y_lat);*/
        /* add trail data */

        if(track_station_on==1)
          {/*printf("Station %s Moving looking for %s\n",fill.call_sign,tracking_station_call);*/
           track_station(da,tracking_station_call,fill.call_sign,fill.long_pos,fill.lat_pos);
	  }

        /* reject jumps to 0 lat 0 long */
        if(fill.long_pos != 64800000l && fill.lat_pos != 32400000l)  
          {x_diff_long= labs(fill.long_pos-fill_old.long_pos);      
           y_diff_lat = labs(fill.lat_pos-fill_old.lat_pos);

           /*printf("%s delta x %ld y %ld\n",fill.call_sign,x_diff_long,y_diff_lat);*/

           /* I need to check these numbers to see if they give good tracking -FG */  
           if((x_diff_long < 360000l) && (y_diff_lat < 360000l))
             {for(mv=fill_old.num_trail+1; mv>=0;mv--)
                 {fill.trail_long_pos[mv]=fill.trail_long_pos[mv-1];
                  fill.trail_lat_pos[mv]=fill.trail_lat_pos[mv-1];
		 }

              fill.trail_long_pos[0]=fill.long_pos;
              fill.trail_lat_pos[0]=fill.lat_pos;
              fill.num_trail=fill_old.num_trail+1;
              if(fill.num_trail>MAX_TRACKS)
                {fill.num_trail=MAX_TRACKS;}
	    
              /* max off screen values */
              max_x = screen_width+800l;
              max_y = screen_height+800l;

              /* see if this station is old */
              if((sec_clear+fill.sec_heard)>sec_now())  
                {if(station_trails)
                   {if(fill.num_trail>1)
                      {XSetForeground(XtDisplay(da),gc,trail_colors[fill.trail_color]);
                       XSetLineAttributes(XtDisplay(da), gc, 3, LineSolid, CapRound, JoinRound);                       
                       for(iii=0; iii<(fill.num_trail-1); iii++)
                          {x_origin = ((fill.trail_long_pos[(iii+1)]-x_long_offset)/size);
                           y_origin = ((fill.trail_lat_pos[(iii+1)]-y_lat_offset)/size);
                           x = ((fill.trail_long_pos[iii]-x_long_offset)/size);
                           y = ((fill.trail_lat_pos[iii]-y_lat_offset)/size);

                           /* REJECT LONG LINES */ 
                           x_diff_long= labs(x_origin-x);      
                           y_diff_lat = labs(y_origin-y);

                           if((x_diff_long < ((long)screen_width*3l)) && (y_diff_lat < ((long)screen_height)*3))
                             {if(x_origin > (-800l) && (x_origin< max_x))
		                {if(y_origin > (-800l) && (y_origin< max_y))
	                           {if(x > (-800l) && (x< max_x))
	                              {if(y > (-800l) && (y< max_y))
				         {XDrawLine(XtDisplay(da), pixmap_final, gc, x_origin, y_origin, x, y);  
                                          XDrawLine(XtDisplay(da),XtWindow(da), gc, x_origin, y_origin, x, y);
                                          /*printf("%s Track %ld %ld to %ld %ld\n",fill.call_sign,x_origin,y_origin,x,y);*/
					 }
				      }
				   }
			        }
			     }
			  }
		      }
		   }
		}
	     }
	  }
          else
          {/*printf("%s Track Jumped to 0 lat 0 long ignoring \n",fill.call_sign);*/}

       }

    /* check if station is is current window */ 
    if((fill.long_pos>x_long_offset) && (fill.long_pos<(x_long_offset+(long)(screen_width*size))))
      {if((fill.lat_pos>y_lat_offset) && (fill.lat_pos<(y_lat_offset+(long)(screen_height*size))))
         {/* object is in current window */
          if((labs((fill_old.long_pos+(size/2))-fill.long_pos)/size)>0 
            || (labs((fill_old.lat_pos+(size/2))-fill.lat_pos)/size)>0)  
            {/* object has changed position */
             if(size<300)
               {redraw_on_new_data=2; /* redraw now */
                /*printf("RDN: %s Move in window %ld,  by %ld and %ld\n",fill.call_sign,size,labs(((fill_old.long_pos+(size/2))/size)-(fill.long_pos/size)),labs(((fill_old.lat_pos+(size/2))/size)-(fill.lat_pos/size)));*/
               }
               else
               {redraw_on_new_data=1; /* redraw next chance */
                /*printf("RDL: %s Move in window %ld,  by %ld and %ld\n",fill.call_sign,size,labs(((fill_old.long_pos+(size/2))/size)-(fill.long_pos/size)),labs(((fill_old.lat_pos+(size/2))/size)-(fill.lat_pos/size)));*/
	       }
	     }
             else
             {/* data change in window */
              if(size<300)
               {redraw_on_new_data=2; /* redraw now */
                /*printf("RDN: %s Data change in window\n",fill.call_sign);*/
               }
               else
               {redraw_on_new_data=1; /* redraw next chance */
                /*printf("RDL: %s Data change in window\n",fill.call_sign);*/
	       } 

	     }
	  }
      }
    }
    else
    {/* New data */

     /* if new assign a trail color */
     current_trail_color = (current_trail_color + 1) % max_trail_colors;
     fill.trail_color=current_trail_color;
     /*printf("%s NEW trail color %d\n",fill.call_sign,fill.trail_color);*/

     if((x_long>x_long_offset) && (x_long<(x_long_offset+(long)(screen_width*size))))
       {if((y_lat>y_lat_offset) && (y_lat<(y_lat_offset+(long)(screen_height*size))))
          {/* new data in window */
           /*redraw_on_new_data=1;*/

           strcpy(temp_altitude,"");
           strcpy(temp_course,"");
           strcpy(temp_speed,"");
           strcpy(temp_my_distance,"");
           strcpy(temp_my_course,"");
           temp_sec_heard=0l;

           strcpy(temp_wx_temp,"");
           strcpy(temp_wx_wind,"");
           if(fill.wx_data==1)
             {if(!units_english_metric)
                {if(strlen(fill.wx_temp)>1)
                   {sprintf(wx_tm,"T:%03d C",(int)(((atof(fill.wx_temp)-32)*5.0)/9.0));
                    strcat(temp_wx_temp,wx_tm);
		   }
                 if(strlen(fill.wx_hum)>1)
                   {if(strlen(fill.wx_temp)>1)
                      {strcat(temp_wx_temp,"  ");}
                    sprintf(wx_tm,"H:%s%%",fill.wx_hum);
                    strcat(temp_wx_temp,wx_tm);
		   }

                 if(strlen(fill.wx_speed)>1)
                   {sprintf(wx_tm,"S:%03d Kph",(int)(atof(fill.wx_speed)*1.6094));
                    strcat(temp_wx_wind,wx_tm);
		   }
                 if(strlen(fill.wx_gust)>1)
                   {if(strlen(fill.wx_speed)>1)
                      {strcat(temp_wx_wind," ");}
                    sprintf(wx_tm,"G:%03d Kph",(int)(atof(fill.wx_gust)*1.6094));
                    strcat(temp_wx_wind,wx_tm);
		   }
                 if(strlen(fill.wx_course)>1)
                   {if(strlen(fill.wx_speed)>1 || strlen(fill.wx_gust)>1)
                      {strcat(temp_wx_wind," ");}
                    sprintf(wx_tm,"C:%s",fill.wx_course);
                    strcat(temp_wx_wind,wx_tm);
		   }
		}
                else
                {if(strlen(fill.wx_temp)>1)
                   {sprintf(wx_tm,"T:%s F",fill.wx_temp);
                    strcat(temp_wx_temp,wx_tm);
		   }
                 if(strlen(fill.wx_hum)>1)
                   {if(strlen(fill.wx_temp)>1)
                      {strcat(temp_wx_temp,"  ");}
                    sprintf(wx_tm,"H:%s%%",fill.wx_hum);
                    strcat(temp_wx_temp,wx_tm);
		   }

                 if(strlen(fill.wx_speed)>1)
                   {sprintf(wx_tm,"S:%s Mph",fill.wx_speed);
                    strcat(temp_wx_wind,wx_tm);
		   }
                 if(strlen(fill.wx_gust)>1)
                   {if(strlen(fill.wx_speed)>1)
                      {strcat(temp_wx_wind," ");}
                    sprintf(wx_tm,"G:%s Mph",fill.wx_gust);
                    strcat(temp_wx_wind,wx_tm);
		   }
                 if(strlen(fill.wx_course)>1)
                   {if(strlen(fill.wx_speed)>1 || strlen(fill.wx_gust)>1)
                      {strcat(temp_wx_wind," ");}
                    sprintf(wx_tm,"C:%s",fill.wx_course);
                    strcat(temp_wx_wind,wx_tm);
		   }
		}
	     }

           sprintf(temp_long,"%s%c",fill.long_pos_x,fill.long_ew);
           sprintf(temp_lat,"%s%c",fill.lat_pos_y,fill.lat_ns);
           
           if(strcmp(fill.call_sign,my_callsign)!=0)
             {temp_sec_heard = fill.sec_heard;}
             else
             {temp_sec_heard = sec_now();}
                      
           if(strlen(fill.altitude)>0)
             {if(!units_english_metric)
                {sprintf(temp_altitude,"%s %c",fill.altitude,fill.alt_unit);}
                else
                {sprintf(temp_altitude,"%.1f %s",atof(fill.altitude)*3.28084,"Ft");}
	     }

           if(strlen(fill.course)>0)
             {sprintf(temp_course,"%s Deg",fill.course);}

           if(strlen(fill.speed)>0)
             {if(!units_english_metric)
                {sprintf(temp_speed,"%.1f KPH",atof(fill.speed)*1.852);}
                else
                {sprintf(temp_speed,"%.1f MPH",atof(fill.speed)*1.1508);}
	     }

           /* do my course */
           if(strcmp(fill.call_sign,my_callsign)!=0)
             {if(units_english_metric)
                {sprintf(temp_my_distance,"%0.1f Miles",(distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.15078));}
                else
                {sprintf(temp_my_distance,"%0.1f Km",(distance_between_string(my_lat,my_long,temp_lat,temp_long,temp1_my_course)*1.852));}
              sprintf(temp_my_course,"%s Deg",temp1_my_course);
	     }

          if(fill.call_sign[(strlen(fill.call_sign)-1)]=='*')
            {fill.call_sign[(strlen(fill.call_sign)-1)]=0;}


           draw_symbol(da,fill.aprs_symbol.aprs_type,fill.aprs_symbol.aprs_symbol,
		       fill.aprs_symbol.special_overlay,
                       x_long,y_lat,fill.call_sign,temp_altitude,temp_course,temp_speed,
		       temp_my_distance,temp_my_course,temp_wx_temp,temp_wx_wind,temp_sec_heard,
		       XtWindow(da));

           draw_symbol(da,fill.aprs_symbol.aprs_type,fill.aprs_symbol.aprs_symbol,
		       fill.aprs_symbol.special_overlay,
                       x_long,y_lat,fill.call_sign,temp_altitude,temp_course,temp_speed,
		       temp_my_distance,temp_my_course,temp_wx_temp,temp_wx_wind,fill.sec_heard,
		       pixmap_final);

           if(strlen(fill.power_gain)>3 && show_phg)
             {/*printf("PHG:%s\n",fill.power_gain);*/
              draw_phg(fill.long_pos,fill.lat_pos,fill.power_gain,fill.sec_heard,pixmap_final);
              draw_phg(fill.long_pos,fill.lat_pos,fill.power_gain,fill.sec_heard,XtWindow(da));
	     }
            
	  }
       }
    }

  strncpy(fill.call_sign,call_sign,MAX_CALLSIGN);
  if(call_sign[0]=='}')
    {strncpy(fill.call_sign,call_sign+1,(MAX_CALLSIGN-1));
     fill.pass_thru = TRUE;
    }
    else
    {fill.pass_thru = FALSE;}
   call_len=strlen(fill.call_sign); 

  if(fill.call_sign[(call_len-1)]=='*')
    {fill.call_sign[(call_len-1)]=0;}

  if(strcmp(fill.call_sign,my_callsign)!=0)
    {sprintf(your_lat,"%s%c",fill.lat_pos_y,fill.lat_ns);
     sprintf(your_long,"%s%c",fill.long_pos_x,fill.long_ew);
     if(record == -1l)
       {/* NEW record */
        if(!wait_to_redraw)
          {sprintf(station_id,langcode("BBARSTA001"),fill.call_sign); 
           XmTextFieldSetString (text, station_id);
           fill.num_packets=1;
           /*printf("Packets for %s = %d\n",fill.call_sign,fill.num_packets);*/

           if(sound_play_new_station) 
             {play_sound(sound_command,sound_new_station);}
	  }
        fill.num_trail=0;  
        mem_input_database(fill);
       }
       else
       {/* OLD record - NEW DATA */
        /*printf("NEW DATA %s  PT %s POST %s\n",fill.call_sign,fill.packet_time,fill.pos_time);*/ 
        fill.num_packets=fill_old.num_packets+1;
        /*printf("Packets for %s = %d\n",fill.call_sign,fill.num_packets);*/
 
        mem_replace_data(fill,record);
        if(!wait_to_redraw)
          {sprintf(station_id,langcode("BBARSTA002"),fill.call_sign); 
           XmTextFieldSetString (text, station_id);
	  }
       }
    }
    else
    {/* my station */
     if(record != -1)
       {fill_old.num_packets++;
        /*printf("Packets for %s = %d\n",fill_old.call_sign,fill_old.num_packets)*/
        mem_replace_data(fill_old,record);
       }  
    }
 }
  }

}


void my_station_gps_change(char *pos_long, char *pos_lat, char *course, char *speed, char speedu, char *alt, char altu, char *sats)
{DataRow fill;
 int record;
 char time_data[MAX_TIME];
 long pos_long_temp, pos_lat_temp;
 char temp_data[40];
 char temp_lat[10];
 char temp_long[10]; 

strncpy(fill.call_sign,my_callsign,MAX_CALLSIGN);
record = mem_find_data(fill);
clear_data(&fill);
if(record != -1l)
  {/* fill old data */
   mem_get_data(&fill,record);
  }
  else
  {fill.num_packets=0;}


fill.active = RECORD_ACTIVE;
fill.data_via = 'L';
fill.pass_thru= FALSE;
fill.record_type = NORMAL_APRS;
fill.num_trail=0;
strncpy(fill.call_sign,my_callsign,MAX_CALLSIGN);
strncpy(fill.node_path,"local",MAX_PATH);
strcpy(fill.packet_time,get_time(time_data));
strcpy(fill.pos_time,get_time(time_data));
fill.message_capable = 'Y';

/* convert to long and weed out any odd data */
pos_long_temp=convert_long_string(pos_long);
pos_lat_temp=convert_lat_string(pos_lat);

/* convert to back to clean string for config data */
convert_long_long_string(pos_long_temp,temp_data);
sprintf(temp_long,"%c%c%c%c%c.%c%c%c",temp_data[0],temp_data[1],temp_data[2], temp_data[4],temp_data[5], temp_data[7],temp_data[8], temp_data[9]);
convert_long_lat_string(pos_lat_temp,temp_data);
sprintf(temp_lat,"%c%c%c%c.%c%c%c",temp_data[0],temp_data[1],temp_data[3],temp_data[4], temp_data[6],temp_data[7], temp_data[8]);

/* fill the data in */
strcpy(my_long,temp_long);
strncpy(fill.long_pos_x,my_long,8);
fill.long_ew = my_long[8];

strcpy(my_lat,temp_lat);
strncpy(fill.lat_pos_y,my_lat,7);
fill.lat_ns = my_lat[7];         

if(debug_level)
  {printf("MY_LAT <%s> MY_LONG <%s>\n", my_lat, my_long);}

if((fill.long_pos != pos_long_temp) || (fill.lat_pos != pos_lat_temp))
  {/* check to see if enough to change pos on screen */
    if((pos_long_temp>x_long_offset) && (pos_long_temp<(x_long_offset+(long)(screen_width*size))))
      {if((pos_lat_temp>y_lat_offset) && (pos_lat_temp<(y_lat_offset+(long)(screen_height*size))))
         {if((labs((fill.long_pos+(size/2))-pos_long_temp)/size)>0 
            || (labs((fill.lat_pos+(size/2))-pos_lat_temp)/size)>0)  
            {redraw_on_new_data=1;
             /*printf("Redraw on new gps data \n");*/
             sprintf(temp_data,"Position Change on My Station"); 
             XmTextFieldSetString(text, temp_data);
	    }
	 }
      }
  }

fill.long_pos=pos_long_temp;
fill.lat_pos=pos_lat_temp;

strcpy(fill.altitude_time,get_time(time_data));
strcpy(fill.speed_time,get_time(time_data));
strcpy(fill.speed,speed);
fill.speed_unit=speedu;
strcpy(fill.course,course);
strcpy(fill.altitude,alt);
fill.alt_unit=altu;
/* get my last altitude meters to feet */
my_last_altitude=(long)(atof(alt)*3.28084);
/* get my last course in deg */
my_last_course=atoi(course);
/* get my last speed knots to mph */
my_last_speed=(int)(atof(speed)*1.1508);
strcpy(fill.sats_visible,sats);

if(record != -1l)
  {mem_replace_data(fill,record);}
  else
  {mem_input_database(fill);}
}

 


void my_station_add(char *my_callsign, char my_group, char my_symbol, char *my_long, char *my_lat, char *my_phg, char *my_comment)
{DataRow fill;
 int record;
 char time_data[MAX_TIME];
 char lat_s[20];
 char long_s[20];

strncpy(fill.call_sign,my_callsign,MAX_CALLSIGN);
record = mem_find_data(fill);
clear_data(&fill);
if(record != -1l)
  {/* fill old data */
   mem_get_data(&fill,record);
   /*printf("OLD DATA %s  PT %s POST %s\n",fill.call_sign,fill.packet_time,fill.pos_time);*/
  }
  else
  {fill.num_packets=0;}


fill.active = RECORD_ACTIVE;
fill.data_via = 'L';
fill.pass_thru= FALSE;
fill.record_type = NORMAL_APRS;
fill.num_trail=0;
strncpy(fill.call_sign,my_callsign,MAX_CALLSIGN);
strncpy(fill.node_path,"local",MAX_PATH);
strcpy(fill.packet_time,get_time(time_data));
strcpy(fill.pos_time,get_time(time_data));
fill.message_capable = 'Y';
/* Symbol overlay */
if(my_group != '/' && my_group !='\\')
  {/* Symbol overlay */
   fill.aprs_symbol.aprs_type = '\\';
   fill.aprs_symbol.special_overlay = my_group;
  }
  else
  {fill.aprs_symbol.aprs_type = my_group;
   fill.aprs_symbol.special_overlay=' ';
  }
fill.aprs_symbol.aprs_symbol = my_symbol;
strncpy(fill.long_pos_x,my_long,8);
fill.long_ew = my_long[8];
strncpy(fill.lat_pos_y,my_lat,7);
fill.lat_ns = my_lat[7];
sprintf(long_s,"%s%c",fill.long_pos_x,fill.long_ew);
sprintf(lat_s,"%s%c",fill.lat_pos_y,fill.lat_ns);
fill.long_pos=convert_long_string(long_s);
fill.lat_pos=convert_lat_string(lat_s);

/*printf("my_long %s %c lat %s %c\n",my_long,my_long[8],my_lat,my_lat[7]);*/
strncpy(fill.power_gain,my_phg,7);
strncpy(fill.comments,my_comment,MAX_COMMENTS);

if(record != -1l)
  {mem_replace_data(fill,record);}
  else
  {mem_input_database(fill);}
}


void station_del(char *callsign)
{DataRow fill;
 int record;

strncpy(fill.call_sign,callsign,MAX_CALLSIGN);
record = mem_find_data(fill);
clear_data(&fill);
if(record != -1l)
  {/* fill old data */
   mem_get_data(&fill,record); 
   fill.active = RECORD_NOTACTIVE;
   mem_replace_data(fill,record);
  }
}

void display_packet_data(void)
{int i;
 int pos;
pos=0;
if((Display_data_dialog != NULL) && (redraw_on_new_packet_data==1))
  {XtVaSetValues(Display_data_text,XmNcursorPosition,&pos,NULL);
   XmTextSetString(Display_data_text,"");   
   for(i=0; i<packet_data_display; i++)
      {XmTextInsert(Display_data_text,pos,packet_data[i]);
       pos=pos+strlen(packet_data[i]);
       XtVaSetValues(Display_data_text,XmNcursorPosition,pos,NULL);
      }             
  }
redraw_on_new_packet_data=0;
}

void packet_data_add(char *from, char *line)
{int i;
 int offset;

 offset=0;

 if (line[0]==3) {
    offset=1;
 }

 if ( (Display_packet_data_type==1 && strcmp(from,langcode("WPUPDPD005"))==0) ||
      (Display_packet_data_type==2 && strcmp(from,langcode("WPUPDPD006"))==0) || 
       Display_packet_data_type==0
    )
  {redraw_on_new_packet_data=1;
   if(packet_data_display<15)
     {if(strlen(line)<256)
        {strcpy(packet_data[packet_data_display],from);
         strcat(packet_data[packet_data_display],"-> ");
         strcat(packet_data[packet_data_display],line+offset);
         strcat(packet_data[packet_data_display++],"\n\0");
	}
        else
        {strcpy(packet_data[packet_data_display],from);
         strcat(packet_data[packet_data_display],"-> ");
         strncat(packet_data[packet_data_display],line+offset,256);
         strcat(packet_data[packet_data_display++],"\n\0");
	}
     }
     else
    {packet_data_display=15;
     for(i=0; i<14; i++)
        {strcpy(packet_data[i],packet_data[i+1]);}

     if(strlen(line)<256)
       {strcpy(packet_data[14],from);
        strcat(packet_data[14],"-> ");
        strcat(packet_data[14],line+offset);
        strcat(packet_data[14],"\n\0");
       }
       else
       {strcpy(packet_data[14],from);
        strcat(packet_data[14],"-> ");
        strncat(packet_data[14],line+offset,256);
        strcat(packet_data[14],"\n\0");
       }
    }
  }
}

/* This function attempts to figure out the type of data received,
   then calls data_add with a keyword which describes the data.
   data_add then does the actual decoding of the packet message. */

/* Note that the structure here isn't set up for handling
   compressed mode lat/lon on every possible type of message.    */

void decode(char *call_sign, char *path, char *message, char from, int port)
{
int id_num;
int i;
int offset;
int found;
char line[MAX_TNC_LINE_SIZE+1];
char data[MAX_TNC_LINE_SIZE+1];
char *temp_ptr;
char packet_message[300];
char ipacket_message[300];
char id[20];
char id_fixed[20];
char from_call[MAX_CALLSIGN+1];
char to_call[MAX_CALLSIGN+1];
int id_size;
char ack[20];
int call_ok;
char s_b1;
char s_b2;
char s_b3;
char s_b4;
char s_b5;
char s_b6;
char s_b7;
int n,w,l;
int d,m,h;
char temp[40];
char new_message[40];

int ok_igate_net;

int message_size;
/*int pos, mw_p;
char temp_m[305];
*/

/*clear ok_igate_net, copy message to data for clean message data*/
ok_igate_net=0;
strcpy(data,message);

/* look for aprs type */
/* remember fixed format starts with ! and can be up to 24 chars in the message */
/* we will look for the others first */

message_size=strlen(message);

if(debug_level & 1)
  {printf("decode c:%s p:%s m:%s f:%c\n",call_sign,path,message,from);}

call_ok=1;
/* check for correct callsign info */

for(i=0;i<strlen(call_sign);i++)
   {if((i==0 && (call_sign[0]!='}' && call_sign[0]!=':')) || (i>0))
      {if(!(isalnum(call_sign[i]) || call_sign[i]=='-' || call_sign[i]=='*'))
         {call_ok=0;
          if(debug_level & 1)
            {printf("Bad callsign <%s>\n",call_sign);}
          i=strlen(call_sign)+1;
	 }
      }
   }

if(debug_level & 1)
  {printf("decode Past check\n");}

if(call_ok)
  {if(message_size > 18 && message[0]=='=' && message[5]=='.' && message[15]=='.' 
     && (toupper(message[8])=='N' || toupper(message[8])=='S') 
     && (toupper(message[18])=='W' || toupper(message[18])=='E'))
     /* Can have special character here  like N */
     {/* found message capable aprs ? */
      /* use 9 for weather or normal */
      if(debug_level & 1)
        {printf("FOUND MESSAGE CAPABLE:%s:%s\n",call_sign,message);}
      data_add(APRS_MSGCAP,call_sign,path,message,from,port);
      ok_igate_net=1; 
     }
     else
    {if(message_size > 25 && message[0]=='/' && (message[7]=='/' || message[7]=='h' || message[7]=='z' ) && message[12]=='.' && message[22]=='.' 
        && (toupper(message[15])=='N' || toupper(message[15])=='S') 
        && (toupper(message[25])=='W' || toupper(message[25])=='E')
        && (message[16]=='/' || message[16]=='\\'))
       {/* no Aprs but last time given */
        /*use 16 for weather or normal */
        if(debug_level & 1)
          {printf("FOUND APRS DOWN:%s:%s\n",call_sign,message);}
        data_add(APRS_DOWN,call_sign,path,message,from,port);
        ok_igate_net=1; 
       }
       else
       {if(message_size > 25 && message[0]=='@' && message[12]=='.' && message[22]=='.' 
           && (toupper(message[15])=='N' || toupper(message[15])=='S') 
           && (toupper(message[25])=='W' || toupper(message[25])=='E')
           && (message[7]=='z' || message[7]=='/' || message[7]=='h')
           && (message[16]=='/' || message[16]=='\\'))
          {/* Mobile DX Aprs ?*/
           if(debug_level & 1)
             {printf("FOUND DX-MOBILE:%s:%s\n",call_sign,message);}
           if(message[30]=='/')
             {if(message[34]=='g' && message[38]=='t')
                {if(debug_level & 1)
                   {printf("FOUND WX:%s:%s\n",call_sign,message);}
                 data_add(APRS_WX1,call_sign,path,message,from,port);
                }
                else
                {data_add(APRS_MOBILE,call_sign,path,message,from,port);}

              }
             else
             {data_add(APRS_DF,call_sign,path,message,from,port);}
           ok_igate_net=1;
	  }
          else
          {found=0;
           for(i=0;i<24 && !found && i<strlen(message);i++)
              {if(message_size > (i+18) && message[i]=='!' && message[i+5]=='.' && message[i+15]=='.' 
                  && (toupper(message[i+8])=='N' || toupper(message[i+8])=='S') 
                  && (toupper(message[i+18])=='W' || toupper(message[i+18])=='E'))
                  /* Can have special caracter here  like N */
                  {found=1;
                  /* found Fixed aprs label ?*/
                  /* use i+9 for weather or normal */
                  if(debug_level & 1)
                    {printf("FOUND FIXED at %d:%s:%s\n",i,call_sign,message);}
                  data_add(APRS_FIXED,call_sign,path,message+i,from,port);
                  ok_igate_net=1;
		  }
	      }

           temp_ptr=NULL;
           if(!found)
             {offset=-1;
              if(message[9]==':')
                {offset=0;}
                else
                {if(message[10]==':')
                   {offset=1;}
		}
              
              temp_ptr = strstr(message,"{");                 /* end_message pointer */
              if(temp_ptr==NULL && offset>=0)
                {/* if temp_ptr is null then there is no line number */
                 if(debug_level & 1)
                   {printf("Possible message? <%s> to <%s> message <%s>\n",call_sign,to_call,message);}
                 /* is this an ack ??*/
                 if(message_size > (12+offset) && message[10+offset]=='a' && message[11+offset]=='c' && message[12+offset]=='k')     
                   {strcpy(id,(message+offset+13));
                    strncpy(to_call,message+offset,9);
                    to_call[9]=0;
                    remove_trailing_spaces(to_call);
                    if(debug_level & 1)
                      {printf("Ack from <%s> to <%s> id <%s>\n",call_sign,to_call,id);}
                    if(strcmp(to_call,my_callsign)==0)
                      {/*printf("Got my msg\n");*/
                       clear_acked_message(call_sign,to_call,id);
                      } 
                      else
                      {/* IGATE */
                       /* OK regardless this ACK is  not for me      */
                       /* Now if I have Igate on and I allow to retransmit station data           */
                       /* check if this message is to a person I have heard on my TNC within an X */
                       /* time frame. If if is a station I heard and all the conditions are ok    */
                       /* spit the ACK out on the TNC -FG                                     */
                       
                        if(operate_as_an_igate>1 && from==DATA_VIA_NET && strcmp(my_callsign,call_sign)!=0 && strcmp(my_callsign,to_call)!=0 )
                          {/*printf("Igate check o:%d f:%c myc:%s cf:%s ct:%s\n",operate_as_an_igate,from,my_callsign,call_sign,to_call);*/
                           sprintf(ipacket_message,"}%s>%s:%s",call_sign,path,message);
                           output_igate_rf(call_sign,to_call,path,ipacket_message,port);
			  }
                       ok_igate_net=1;  
		      }
		   }
                   else
                   {/* not and ack with no line number ?*/
                    strncpy(to_call,message+offset,9);
                    to_call[9]=0;
                    remove_trailing_spaces(to_call);
                    remove_trailing_asterisk(call_sign);
                    strncpy(packet_message,(message+offset+10),(strlen(message)-offset-10));
                    packet_message[(strlen(message)-offset-10)]=0;
                    if(debug_level & 1)
                      {printf("Possible message with no line number <%s> to <%s> message <%s>\n",call_sign,to_call,packet_message);}
                    /* Could be APRS MESSAGE with no line number!!*/
                    if(strcmp(my_callsign,to_call)==0)
                      {/* this is a message to me but it has no line number!! */
                       /* so I will do some thing with it and not ack it */
                       /* first I will look to see if it is a query */
                       if(packet_message[0]=='?')
                         {/* this is a possible query for me */
                          printf("ME-PQM-from:%s to:%s msg:%s\n",call_sign,to_call,packet_message);
                          if(strncmp("?APRS?",packet_message,6)==0)
                            {printf("FOUND GENERAL QUERY FOR ME:%s\n",packet_message+6);
			    }
                          if(strncmp("?IGATE?",packet_message,7)==0)
                            {printf("FOUND IGATE QUERY FOR ME:%s\n",packet_message+7);
			    }
                          if(strncmp("?WX?",packet_message,4)==0)
                            {printf("FOUND WX QUERY FOR ME:%s\n",packet_message+4);
			    }
                          if(strncmp("?APRSD",packet_message,6)==0)
                            {printf("FOUND HEARD DIRECT QUERY FOR ME:%s\n",packet_message+6);
			    }
                          if(strncmp("?APRSH",packet_message,6)==0)
                            {printf("FOUND POSITION HEARD QUERY FOR ME:%s\n",packet_message+6);
			    }
                          if(strncmp("?APRSM",packet_message,6)==0)
                            {printf("FOUND OUTSTANDING MESSAGES QUERY FOR ME:%s\n",packet_message+6);
			    }  
                          if(strncmp("?APRSO",packet_message,6)==0)
                            {printf("FOUND STATIONS OBJECTS QUERY FOR ME:%s\n",packet_message+6);
			    }
                          if(strncmp("?APRSP",packet_message,6)==0)
                            {printf("FOUND STATIONS POSITION QUERY FOR ME:%s\n",packet_message+6);
			    }
                          if(strncmp("?APRSS",packet_message,6)==0)
                            {printf("FOUND STATUS QUERY FOR ME:%s\n",packet_message+6);
			    }
                          if(strncmp("?APRST",packet_message,6)==0)
                            {printf("FOUND ROUTE TRACE QUERY FOR ME:%s\n",packet_message+6);
			    }
			 }
                         else
                         {/* this is another message for me possible return data from a query */
                          if(debug_level & 1)     
                            {printf("ME-ANM-from:%s to:%s msg:%s\n",call_sign,to_call,packet_message);}
			 }
		      }
                      else
                      {/* ACCORDING TO APRS SPEC We should get bulletins and NWSalerts this way */
                       if(message[0+offset]=='B' && message[1+offset]=='L' && message[2+offset]=='N')
                         {/* Could be APRS BULLETIN */
                          if(debug_level>1)
                            {printf("BULLETIN%c: <%s> - %s - NO ID\n",from,call_sign,packet_message);}
                          /* BULLETIN */
                          /* I need to do something with these store them for now -FG */
                          mdata_add(to_call,call_sign,packet_message,"",MESSAGE_BULLETIN,from);
                          ok_igate_net=1;
			 }
                         else if (message[0+offset]=='N' && message[1+offset]=='W' && message[2+offset]=='S')
                         {/* Could be Weather Alert */
                          if(debug_level & 1)
                            {printf("NWS Alert%c: <%s> - %s - NO ID\n",from,call_sign,packet_message);}
                          /* NWS Alert */
                          mdata_add(to_call,call_sign,packet_message,"",MESSAGE_NWS,from);
                          alert_message_scan();
                          ok_igate_net=1;
			 }
                         else if(packet_message[0]=='?')
                         {/* this is a possible query */
                          if(debug_level>1)
                            {printf("NOTME-PQM-from:%s to:%s msg:%s\n",call_sign,to_call,packet_message);}
                          ok_igate_net=1; 
 			 }
                         else
                         {/* this is another message type */
                          if(debug_level>1)     
                            {printf("NOTME-ANM-from:%s to:%s msg:%s\n",call_sign,to_call,packet_message);}
                          ok_igate_net=1;
			 }
                         

		      }
		   }
			 
		}

              if(offset>=0 && temp_ptr!=NULL) 
                {/* Could be APRS MESSAGE, BULLETIN?, NWS WARN? */
                 if(debug_level & 1)
                      {printf("Possible message2? <%s> message <%s>\n",call_sign,message);}
                 id_size=strlen(temp_ptr);
                 if(temp_ptr> (message+offset+9))
		   {strncpy(packet_message,(message+offset+10),(strlen(message)-offset-10-id_size));
                    packet_message[(strlen(message)-offset-10-id_size)]=0;
                    strcpy(id,(temp_ptr+1));
                    id[id_size-1]=0;
                    if(is_num(id))
                      {id_num=atoi(id);
                       sprintf(id_fixed,"%05d",id_num);
		      }
                      else
                      {strcpy(id_fixed,id);}
                     strncpy(to_call,message+offset,9);
                     to_call[9]=0;
                     remove_trailing_spaces(to_call);
                     remove_trailing_asterisk(call_sign);
                     if(debug_level & 1)
                       {printf("Possible message3? <%s> to <%s> id <%s> m:<%s>\n",call_sign,to_call,id,message+offset);}

                     /* Shouldn't get bulletins  or NWS here but I have seen this on the net */
                     if(message[0+offset]=='B' && message[1+offset]=='L' && message[2+offset]=='N')
                       {/* Could be APRS BULLETIN */
                       if(debug_level & 2)
                            {printf("BULLETIN%c: <%s> - %s - %s\n",from,call_sign,packet_message,id_fixed);}
                       /* BULLETIN */
                       /* I need to do something with these store them for now -FG */
                       mdata_add(to_call,call_sign,packet_message,"",MESSAGE_BULLETIN,from);
                       ok_igate_net=1;
		      }
                     else if (message[0+offset]=='N' && message[1+offset]=='W' && message[2+offset]=='S')
                     {/* Could be Weather Alert */
                       if(debug_level & 1)
                         {printf("NWS Alert%c: <%s> - %s - %s\n",from,call_sign,packet_message,id_fixed);}
                       /* NWS Alert */
                       mdata_add(to_call,call_sign,packet_message,"",MESSAGE_NWS,from);
                       alert_message_scan();
                       ok_igate_net=1;
                     } 
                      else
                      {/* Could be APRS MESSAGE */
                       if(strcmp(my_callsign,to_call)==0)
                         {if(debug_level & 2)
                            {printf("MESSAGE FOR ME from %c <%s> len %d>%s - %s \n",from,call_sign,strlen(packet_message),packet_message,id_fixed);}
                           mdata_add(to_call,call_sign,packet_message,id_fixed,MESSAGE_MESSAGE,from);
                           new_message_data+=1;
                           check_popup_window(call_sign);

                           /* ack the message */
                           pad_callsign(from_call,call_sign);
                           /* Add the leading ":" for messages as per APRS Spec */           
                           sprintf(ack,":%s:ack%s",from_call,id);
                           transmit_message_data(call_sign,ack);

                           if(sound_play_new_message) 
                             {play_sound(sound_command,sound_new_message);}

                           if(auto_reply==1)
                            {if(debug_level & 2)
                                {printf("Send autoreply to <%s> from <%s> :%s\n",call_sign,my_callsign,auto_reply_message);}
                              if(strcmp(my_callsign,call_sign)!=0)
			          {output_message(my_callsign,call_sign,auto_reply_message);}
			     }
			 }
                         else
                         {if(debug_level & 2)
                            {printf("MESSAGE%c to %s:%s len %d>%s - %s\n",from,to_call,call_sign,strlen(packet_message),packet_message,id_fixed);}

                          /* OK when I GET Group messages straight check here if the Message is for my GROUP(s) */
                          /* but do this stuff for now -FG */
                           mdata_add(to_call,call_sign,packet_message,id_fixed,MESSAGE_MESSAGE,from);
                           new_message_data += look_for_open_group_data(to_call);
                           /*check_popup_window(call_sign);*/
                           /*update_messages();*/

                         /* IGATE */
                         /* OK regardless of group message or not this is a message not for me      */
                         /* Now if I have Igate on and I allow to retransmit station data           */
                         /* check if this message is to a person I have heard on my TNC within an X */
                         /* time frame. If if is a station I heard and all the conditions are ok    */
                         /* spit the message out on the TNC -FG                                     */
                         
                         if(operate_as_an_igate>1 && from==DATA_VIA_NET && strcmp(my_callsign,call_sign)!=0 && strcmp(my_callsign,to_call)!=0 )
                           {/*printf("Igate check o:%d f:%c myc:%s cf:%s ct:%s\n",operate_as_an_igate,from,my_callsign,call_sign,to_call);*/
                            sprintf(ipacket_message,"}%s>%s:%s",call_sign,path,message);
                            output_igate_rf(call_sign,to_call,path,ipacket_message,port);
			   }
                          ok_igate_net=1;
			 }
		      }
		   }
		}
                else
                {if(message[0]=='$' && message[3]=='G' && message[4]=='G' && message[5]=='A')
                   {/* FOUND GPS DATA WITH ALTITUDE ?*/
                    if(debug_level & 1)
                      {printf("FOUND GGA:%s:%s\n",call_sign,message);}
                    data_add(GPS_GGA,call_sign,path,message,from,port);
                    ok_igate_net=1;
		   }
                   else
                   {if(message[0]=='$'&& message[3]=='R' && message[4]=='M' && message[5]=='C')
                      {/* FOUND GPS WITH COURSE AND SPEED ? */
                       if(debug_level & 1)
                         {printf("FOUND RMC:%s:%s\n",call_sign,message);}
                       data_add(GPS_RMC,call_sign,path,message,from,port);
                       ok_igate_net=1;
		      }
                      else
		  {if(message[0]=='$'&& message[3]=='G' && message[4]=='L' && message[5]=='L')
		     {/* FOUND GPS WITH SIMPLE LAT/LONG ? */
                       if(debug_level & 1)
		          {printf("FOUND GLL:%s:%s\n",call_sign,message);}
                       data_add(GPS_GLL,call_sign,path,message,from,port);
                       ok_igate_net=1;
		   }
		else
                      {if(debug_level & 1)
                         {printf("decode look for object\n");}
                       if(message_size > 34 && message[9]=='*'&& message[21]=='.' && message[31]=='.'
                          && (toupper(message[24])=='N' || toupper(message[24])=='S') 
                          && (toupper(message[34])=='W' || toupper(message[34])=='E')
                          && (message[25]=='/' || message[25]=='\\')
                          && (message[16]=='/' || message[16]=='z' || message[16]=='h'))
                         {/* FOUND OBJECT ? */
                          /* use 25 for weather or normal*/
                          strncpy(to_call,message,9); 
                          to_call[9]=0;
                          remove_trailing_spaces(to_call);
                          strncpy(packet_message,(message+10),(strlen(message)-10));
                          packet_message[(strlen(message)-10)]=0;
                          if(debug_level & 1)
                            {printf("OBJECT%c <%s>:%s-\n",from,to_call,packet_message);}
                          /* FG  OBJECT TYPES  */
                          /* if message[0] == ':' or '+' add object */
                          /*               == '-' or '_' del object */
                          /* Work on this later FG */

                          data_add(APRS_OBJECT,to_call,path,packet_message,from,port);
                          ok_igate_net=1;
		         }
                         else
                         {if(message[0]=='>' && (message[7]=='\\' || message[7]=='/'  || message[7]=='z' || message[7]=='h'))  
                            {/* STATUS PACKET? */
                             if(debug_level & 1)
                               {printf("FOUND STATUS:%s:%s\n",call_sign,message);} 
                             ok_igate_net=1;
			    }
                            else
                            {if(message[0]==0x60 || message[0]==0x27)
                               {if(debug_level & 1)
                                  {printf("FOUND MIC-E\n");} 
                                s_b1=path[0];
                                if((s_b1 & 0x10)==0x10)
                                  {s_b2=path[1];
                                   if((s_b2 & 0x10)==0x10)
                                    {s_b3=path[2];
                                     if((s_b3 & 0x10)==0x10)
                                       {s_b4=path[3];
                                        if((s_b4 & 0x10)==0x10)
                                          {s_b5=path[4];
                                           if((s_b5 & 0x10)==0x10)
                                             {s_b6=path[5];
                                              if((s_b6 & 0x10)==0x10)
                                                {s_b7=path[6];
                                                 n=((s_b4&0x40)==0x40);
                                                 l=((s_b5&0x40)==0x40);
                                                 w=((s_b6&0x40)==0x40);
                                                 sprintf(temp,"!%d%d%d%d.%d%d%c%c",(s_b1&0x0f),(s_b2&0x0f),(s_b3&0x0f),(s_b4&0x0f),(s_b5&0x0f),(s_b6&0x0f),(n ? 'N': 'S'), message[8]);
                                                 strcpy(new_message,temp);
                                                 d=(int)message[1]-28;
                                                 if(l)
                                                   {d+=100;}
                                                 if((180<=d)&&(d<=189))
                                                   {d-=80;}
                                                 if((190<=d)&&(d<=199))
                                                   {d-=190;}
                                                 m=(int)message[2]-28;
                                                 if(m>=60)
                                                   {m-=60;}
                                                 h=(int)message[3]-28;
                                                 sprintf(temp,"%03d%02d.%02d%c%c/%s",d,m,h,(w ? 'W': 'E'), message[7],(message+10));
                                                 strcat(new_message,temp);
                                                 if(debug_level & 1) 
                                                   {printf("MIC-E convert %s>%s:%s\n",call_sign,path,new_message);}
                                                 data_add(APRS_FIXED,call_sign,path,new_message,from,port);
						 ok_igate_net=1;
						}
					     }
					  }
				       }
				    }
				  }

			       }
                               else
                               {if(message_size > 13 && message[0]=='_' && message[9]=='c' && message[13]=='s')
                                  {/* standalone WX format? */
                                   if(debug_level & 1)
                                     {printf("FOUND NEW WX:%s:%s\n",call_sign,message);}
                                   data_add(APRS_WX2,call_sign,path,message,from,port);
                                   ok_igate_net=1;
				  }
                                  else
                                  {if(message[0]=='!' && message[1]=='!' && is_xnum_or_dash(message+2,40))
                                     {/* standalone WX format */
                                      if(debug_level & 1)
                                        {printf("Found Peet Bros U2k WX:%s:%s\n",call_sign,message);}
                                      data_add(APRS_WX3,call_sign,path,message,from,port);
                                      ok_igate_net=1;
				     }
                                     else
                                     {if (((message[0]=='#') || (message[0]=='*')) && is_xnum_or_dash(message+1,13)) {
                                         /* standalone WX Format */
                                         if(debug_level & 1)
                                           {printf("Found Peet Bros raw U2 data  WX#:%s:%s,%d\n",call_sign,message,strlen(message));}
                                         data_add(APRS_WX4,call_sign,path,message,from,port);
                                         ok_igate_net=1;
				     } else {
                                       if (strncmp("$ULTW",message,5)==0 && is_xnum_or_dash(message+5,44)) {
                                          /* standalone WX Format */
                                          if(debug_level & 1)
                                            {printf("Found Peet Bros raw U2K paccket data  WX#:%s:%s,%d\n",call_sign,message,strlen(message));}
                                          data_add(APRS_WX5,call_sign,path,message,from,port);
                                          ok_igate_net=1; 
				       }else
                                        {/* First check for YYYYXXXX format (compressed format).  Note that compressed
					    format lat/lon can be used anywhere that a normal lat/lon can be used
					    ( and of '!', '/', '@', or '=' formats ). */
		   
                                         if ( (message_size > 13) && (message[1]=='/')
		                             && ( (message[0]=='=') || (message[0]=='!') || (message[0]=='@') || (message[0]=='/') ) )
			                    {/* If it is a non-message capable APRS program, compressed mode, catch that here */
					     if(message[0]=='/')
				               {if(debug_level & 1)
					          {printf("FOUND APRS DOWN COMPRESSED:%s:%s\n",call_sign,message);}
						data_add(APRS_DOWN_COMPRESSED,call_sign,path,message,from,port);
                                                ok_igate_net=1;
						}
						else 
                                                {/* If it is an APRS fixed message, compressed mode, catch that here */
                                                 if( message[0]=='!' )                               
                                                   {if(debug_level & 1)
	                                              {printf("FOUND FIXED COMPRESSED at %d:%s:%s\n",i,call_sign,message);}
		                                    data_add(APRS_FIXED_COMPRESSED,call_sign,path,message,from,port);
                                                    ok_igate_net=1;
						   }
                                                   else
                                                   {/* If it is a message capable APRS program, compressed mode, catch that here */
                                                    if( message[0]=='=' || message[0]=='@' )
                                                      {if(debug_level & 1)
                                                           {printf("FOUND MESSAGE CAPABLE COMPRESSED:%s:%s\n",call_sign,message);}
                                                       data_add(APRS_MSGCAP_COMPRESSED,call_sign,path,message,from,port);
                                                       ok_igate_net=1; 
						      }
                                                      else
                                                      {/* Check for no-APRS but last time given, compressed mode */
						       if( message_size > 19 && message[0]=='/' && message[8]=='/'
						         && ( message[7]=='/' || message[7]=='!' ) )
						         {/* no Aprs but last time given */
						          if(debug_level & 1)
							      {printf("FOUND APRS DOWN COMPRESSED:%s:%s\n",call_sign,message);}
						          data_add(APRS_DOWN_COMPRESSED,call_sign,path,message,from,port);
                                                          ok_igate_net=1;
							 }
						         else
                                                         {/* DONT KNOW WHAT THIS IS */
                                                          if(debug_level & 1)
                                                            {printf("WHAT!!!:%s:%s\n",call_sign,message);}
							 }
						      }
						   }
						}
					    }
					}
				     }
				  }
				  }
			       }
			    }
			 }
		      }
		   }
		}
		}
	     }
	  }
       }
    }
  }

if(ok_igate_net)
  {/* real aprs packet found do IGATE here!       */
   /* These are only packets that I can decode    */
   /* it should cut down on bogus data out to the */
   /* net perhaps not I need to look at this more */
   /* -FG                                         */
   if(from==DATA_VIA_TNC && strcmp(call_sign,my_callsign)!=0)
     {/* Check to skip third party info */
      if(data[0]!='}')
        {sprintf(line,"%s>%s:%s",call_sign,path,data);
         /*printf("IGATE>NET %s\n",line);*/
         output_igate_net(line, port);
	}
     }
  }

if(debug_level & 1)
   {printf("Decode Stop\n");}
}




void serial_decode(char *line, char from, int port)

{
 char *call_sign;
 char *path;
 char *message;


call_sign=NULL;
path=NULL;
message=NULL;

call_sign=strtok(line,">");

 if (call_sign!=NULL) {
    path=strtok(NULL,":");
    if (path!=NULL) {
       message=strtok(NULL,"");
      if (message !=NULL) {
         if (message[0]=='}') {
            /*printf("Found third party message Transmitted by %s\n",call_sign);*/
            if (strcmp(call_sign,my_callsign)!=0) {
               /* ok this is not a 3 party message my station transmitted */
               call_sign=strtok((message+1),">");
               if (call_sign!=NULL) {
                  /*printf("Found third party Call %s\n",call_sign);*/
                  path=strtok(NULL,":");
                  if (path!=NULL) {
                     /*printf("Found third party path %s\n",path);*/
                     message=strtok(NULL,"");
                     if (message !=NULL) {
                        /*printf("Found third party message %s\n",message);*/
                        if (strlen(call_sign)>1 && strlen(path)>1 && strlen(message)>5)
                           decode(call_sign,path,message,from,port);
		     }
		  }
	       }

	    } else {
              printf("Third party traffic from my station ignoring:%s>%s:%s\n",call_sign,path,message);
	    }

	 } else {
           if (strlen(call_sign)>1 && strlen(path)>1 && strlen(message)>5)
              decode(call_sign,path,message,from,port);
	 }
      }
    }
 }
}


void clean_data_file(void)
{int i;
for(i=0;i<stations;i++)
   {clear_data(&station_data[i]);}
stations=0;
}


void  read_file_line(FILE *f)
{int found;
 char line[MAX_LINE_SIZE+1];
 char cin;
 int pos;

 char *call_sign;
 char *path;
 char *message;

pos=0;
found=0;
strcpy(line,"");
while(!feof(f) && !found)
        {if(fread(&cin,1,1,f)==1)
           {if(cin!=10 && cin !=13)
               {if(pos<MAX_LINE_SIZE)
                  {line[pos++]=cin;
                   line[pos]=0;
		   }
		}
                else
                {if(cin==10)
                   {pos=0;
                    /*printf("LINE %s\n",line);*/
                    call_sign=strtok(line,">");
                    path=strtok(NULL,":");
                    message=strtok(NULL,"");
                    if(call_sign!=NULL && message !=NULL)
                      {decode(call_sign,path,message,'F',-1);
                       found=1;
                      }
                
      		   }
		}
	   
	    }
	}
if(feof(f))
  {fclose(f);
   read_file=0;
   XmTextFieldSetString(text,langcode("BBARSTA012"));
  }
}


int locate_station(Widget w, char *call, int follow_case, int get_match)
{DataRow fill;
 int found;
 int record;
 char call_find[MAX_CALLSIGN+1];
 char call_find1[MAX_CALLSIGN+1];
 char temp_long[20];
 char temp_lat[20];
 int i;
 int ii;
 int call_len;

call_len=0;
found=0;
if(!follow_case)
  {for(ii=0;ii<strlen(call);ii++)
      {if(isalpha(call[ii]))
         {call_find[ii]=toupper(call[ii]);}
         else
         {call_find[ii]=call[ii];}
      }
   call_find[ii]=0;
   strcpy(fill.call_sign,call_find);
  }
  else
  {strcpy(fill.call_sign,call);}

strcpy(call_find1,call);

if(get_match)
  {record = mem_find_data(fill);
   if(record != -1l)
     {found=1;
      mem_get_data(&fill,record); 
      sprintf(temp_long,"%s%c",fill.long_pos_x,fill.long_ew);
      sprintf(temp_lat,"%s%c",fill.lat_pos_y,fill.lat_ns);
      mid_x_long_offset = convert_long_string(temp_long);
      mid_y_lat_offset =convert_lat_string(temp_lat);
      /*printf("Call %s found, pos= %s %c %s %c\n",call_find,fill.long_pos_x,fill.long_ew,fill.lat_pos_y,fill.lat_ns);*/
      create_image(w);
      XCopyArea(XtDisplay(w),pixmap_final,XtWindow(w),gc,0,0,screen_width,screen_height,0,0);
     }
  }
  else
  {found=0;
   for(i=0; (i<stations) && !found;i++)
      {if(station_data[i].active==RECORD_ACTIVE)
       call_len=strlen(station_data[i].call_sign)-strlen(call_find1);
       if(strlen(call_find1)<=strlen(station_data[i].call_sign))
         {for(ii=0; ii<=call_len; ii++)
             {if(!follow_case)
                {if(strncasecmp(call_find1,station_data[i].call_sign+ii,strlen(call_find1))==0)
                   {found=1;
                    sprintf(temp_long,"%s%c",station_data[i].long_pos_x,station_data[i].long_ew);
                    sprintf(temp_lat,"%s%c",station_data[i].lat_pos_y,station_data[i].lat_ns);
                    mid_x_long_offset = convert_long_string(temp_long);
                    mid_y_lat_offset =convert_lat_string(temp_lat);
                    create_image(w);
                    XCopyArea(XtDisplay(w),pixmap_final,XtWindow(w),gc,0,0,screen_width,screen_height,0,0); 
		   }
		}
                else
                {if(strncmp(call_find1,station_data[i].call_sign+ii,strlen(call_find1))==0)
                   {found=1;
                    sprintf(temp_long,"%s%c",station_data[i].long_pos_x,station_data[i].long_ew);
                    sprintf(temp_lat,"%s%c",station_data[i].lat_pos_y,station_data[i].lat_ns);
                    mid_x_long_offset = convert_long_string(temp_long);
                    mid_y_lat_offset =convert_lat_string(temp_lat);
                    create_image(w);
                    XCopyArea(XtDisplay(w),pixmap_final,XtWindow(w),gc,0,0,screen_width,screen_height,0,0); 
		   }
		}

	     }
	 }
      }
  }
return(found);
}


void track_station(Widget w, char *call, char *call_now, long now_long, long now_lat)
{
 int found;
 char call_find[MAX_CALLSIGN+1];
 int ii;
 int call_len;

call_len=0;
found=0;
if(!track_case)
  {for(ii=0;ii<strlen(call);ii++)
      {if(isalpha(call[ii]))
         {call_find[ii]=toupper(call[ii]);}
         else
         {call_find[ii]=call[ii];}
      }
   call_find[ii]=0;
  }
  else
  {strcpy(call_find,call);}


/*printf("CALL %s %s %s\n",call, call_find, call_now);*/

if(track_match)
  {if(strcmp(call_find,call_now)==0)
     {found=1;}
  }
  else
  {found=0;
   call_len=strlen(call_now)-strlen(call_find);
   if(strlen(call_find)<=strlen(call_now))
     {for(ii=0; ii<=call_len; ii++)
         {if(!track_case)
            {if(strncasecmp(call_find,call_now+ii,strlen(call_find))==0)
               {found=1;}
                   
	    }
            else
            {if(strncmp(call_find,call_now+ii,strlen(call_find))==0)
               {found=1;}
                  
	    }
	 }
     }
  }

if(found)
  {mid_x_long_offset = now_long;
   mid_y_lat_offset = now_lat;
   /*printf("Call %s found, pos= %ld %ld\n",call_find,now_long,now_lat);*/
   create_image(w);
   XCopyArea(XtDisplay(w),pixmap_final,XtWindow(w),gc,0,0,screen_width,screen_height,0,0);
  }

}

