#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <signal.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <setjmp.h>
#include <netinet/in.h>
#include <errno.h>
#include <sys/wait.h>

#include "xastir.h"

/* from lang.c */
extern char *langcode(char *code);
extern char langcode_hotkey(char *code);

/* from main.c */
extern void busy_cursor(Widget w);

static  sigjmp_buf ret_place;       /* Jump address if alarm */

/*************************************************************************/
/* Time out on connect                                                   */                    
/* In case there is a problem in getting the hostname or connecting      */
/* (see  setjmp below).                                                  */
/*************************************************************************/

static void host_time_out(int sig)
{ 
 siglongjmp(ret_place,0);
}


/*************************************************************************/
/* do a nice host lookup (don't thread!!)                                */                    
/*                                                                       */ 
/* host: name to lookup                                                  */
/* ip: buffer for ip's must be 400 bytes at least                        */
/* time: time in seconds to wait                                         */
/*                                                                       */
/* return the ip or ip's of the host name                                */
/* or these strings:                                                     */ 
/* NOHOST  for no host by that name found                                */
/* NOIP    for host found but no ip address available                    */
/* TIMEOUT for time execeded                                             */
/*************************************************************************/

char *host_lookup(char *host, char *ip, int time)
{
 /*struct sockaddr_in address;*/
 char **names, **addrs;
 static struct hostent *hostinfo;
 void *previous_loc;
 pid_t host_pid;
 int status;
 char ip_addr[400];
 char temp[40];
 int fp[2];
 char buf[401];
 int ip_found;
 int first;
 int tm;
 int ips;
 int i;
 char ttemp[60];

 memset(ip_addr,'\0',sizeof(ip_addr));
 memset(buf,'\0',sizeof(buf));

 busy_cursor(da);

 if (pipe(fp)==0) {
     
    host_pid = fork();
    if (host_pid!=-1) {

       if (host_pid==0) {

          previous_loc = signal(SIGALRM, host_time_out);

          if (sigsetjmp(ret_place,-1)!=0) {
             
             alarm(0);
             signal(SIGALRM, previous_loc);

             /* return  net connection time out */
             write(fp[1],"TIMEOUT",sizeof(buf)-1);             
             exit(0);
	  }

          alarm(time);

          /*hostinfo = gethostbyname2(host,AF_INET); some systems don't have this*/
          hostinfo = gethostbyname(host);
          
          if (hostinfo) {
             
             names = hostinfo -> h_aliases;
             ip_found=0;

             /* look at all names */
             ips=0; 
             first=0;
             if (!*names)
                first=1;
             while (*names || first) {
                   
                   if (hostinfo -> h_addrtype == AF_INET) {
                      ip_found=1; 
                      addrs = hostinfo -> h_addr_list;
                      while (*addrs) {
                            
                            sprintf(temp,"%s",inet_ntoa(*(struct in_addr *)*addrs));
                            
                            if (strlen(temp)>7) {
                               /* IP found */
                               if((strlen(ip_addr)+strlen(temp))<sizeof(ip_addr)) {
                                  if (ips>0)
                                     strcat(ip_addr," ");
                                  strcat(ip_addr,temp);
                                  ips++;
			       }
			    }
                            addrs++;

		      }
		   }

                   if (first) {
                      *names=NULL;
                      first=0;
		   } else names++;
		      
	     }
             if (ip_found==0) {
                /* Host not found */
                 strcpy(ip_addr,"NOIP"); 
	     }

	  } else {
            /* Host not found */
           strcpy(ip_addr,"NOHOST"); 
	  }

          alarm(0);
          signal(SIGALRM,previous_loc);

          write(fp[1],ip_addr,sizeof(buf)-1);
          exit(0);

       } else {
         /* parent */
         tm=1;    
         while (waitpid(host_pid,&status,WNOHANG)!=-1) {
               sprintf(ttemp,langcode("BBARSTA031"),tm++);
               XmTextFieldSetString(text,ttemp);
               XmUpdateDisplay(text);

               for (i=0; i < 60; i++) {
                   /* update display while waiting */
                   XmUpdateDisplay(XtParent(da));
                   usleep(500);
	       }
	      }

         read(fp[0],buf,sizeof(buf)-1);
         strcpy(ip,buf);
       }
    }
 }

return(ip);
}



int old_main(void)
{char ip_addr[400];

host_lookup("www.aprs.net",ip_addr,50);
printf("IP:<%s>\n",ip_addr);
host_lookup("localhost",ip_addr,50);
printf("IP:<%s>\n",ip_addr);
host_lookup("bubba.eazy.net",ip_addr,200);
printf("IP:<%s>\n",ip_addr);
host_lookup("www.microsoft.com",ip_addr,200);
printf("IP:<%s>\n",ip_addr);
return 0;
}
