
#ifndef __XASTIR_MAPS_H
#define __XASTIR_MAPS_H

#include <X11/Intrinsic.h>

#define MAX_OUTBOUND 900
#define MAX_MAP_POINTS 5000

/* memory structs */

typedef struct
{
  unsigned char vector_start_color;
  unsigned char object_behavior;
  unsigned long longitude;
  unsigned long latitude;
} map_vectors;

typedef struct
{
  unsigned long longitude;
  unsigned long latitude;
  unsigned int mag;
  char label_text[33];
  unsigned char text_color_quad;
} text_label;

typedef struct
{
  unsigned long longitude;
  unsigned long latitude;
  unsigned int mag;
  unsigned char symbol;
  unsigned char aprs_symbol;
  unsigned char text_color;
  char label_text[30];
} symbol_label;

void load_auto_maps(Widget w, char *dir);
void load_maps(Widget w);
void load_alert_maps(Widget w, char *dir);

/* from main.c */
extern char ALERT_MAP_DIR[];
extern char WIN_MAP_DIR[];
extern char WIN_MAP_DATA[]; 

#endif /* __XASTIR_MAPS_H */
