/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea, KC0DGE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <stdio.h> 
#include <sys/ioctl.h> 
#include <ctype.h>

int position_amb_chars;

char *output_lat(char *in_lat)
{int i,j;


j=0;
if(position_amb_chars>0 && position_amb_chars<5)
  {for(i=6;i>(6-position_amb_chars-j);i--)
      {if(i==4)
         {i--;
          j=1;
         }   
      in_lat[i]=' ';
      }
  }
 return(in_lat);
}


char *output_long(char *in_long)
{int i,j;

 j=0;
 if(position_amb_chars>0 && position_amb_chars<5)
   {for(i=7;i>(7-position_amb_chars-j);i--)
       {if(i==5)
          {i--;
           j=1;
          }   
        in_long[i]=' ';
       }
   }
 return(in_long);
}

char *get_line(FILE *f, char *linedata, int maxline)
{char cin;
 int pos;

pos=0;
cin=0;
strcpy(linedata,"");
while(!feof(f) && cin != 13 && cin !=10)
     {if(fread(&cin,1,1,f)==1)
        {if(pos<maxline)
           {if(cin !=13 && cin !=10)
              {linedata[pos++]=cin;}
	   }
	}
        else
        {cin=10;}
     }
linedata[pos]=0;
return(linedata);
}

char *new_get_line(FILE *f, char *linedata, int maxline)
{
    char *ptr;
 int pos;
    static char Buffer[4097];

pos=0;
    *linedata = '\0';
    while((ptr = strpbrk(Buffer, "\r\n")) == NULL && !feof(f) && strlen(Buffer) <= 4096)
      fread(&Buffer[strlen(Buffer)], sizeof(char), sizeof(Buffer)-strlen(Buffer)-1, f);
    if (ptr) *ptr = '\0';
    strncpy(linedata, Buffer, maxline);
    if ((pos = strlen(Buffer)) > maxline)
      fprintf(stderr, "Line length overflow: get_line\n");
    else if (pos < maxline) {
	linedata[pos] = '\0';
    }
    if (ptr) {
	for (ptr++; *ptr == '\r' || *ptr == '\n'; ptr++);
	strcpy(Buffer, ptr);
	   }
    return(linedata);
	}

time_t time_from_aprsstring(char *aprs_time)
{
    int day, hour, minute;
    char tz[20];
    struct tm *time_now, alert_time;
    time_t timenw;
    long zone;

    time(&timenw);
    time_now = localtime(&timenw);
    zone = timezone;
    tz[0] = tz[1] = '\0';
    switch (sscanf(aprs_time, "%2d%2d%2d%s", &day, &hour, &minute, tz)) {
      case 0:
	day = 0;
      case 1:
	hour = 0;
      case 2:
	minute = 0;
      default:
	break;
    }
    alert_time = *time_now;
    alert_time.tm_sec = 0;
    if (day) {
	alert_time.tm_mday = day;
	if (day < (time_now->tm_mday - 10)) {
	    if (++alert_time.tm_mon > 11) {
		alert_time.tm_mon = 0;
		alert_time.tm_year++;
	    }
	}
	if (day > (time_now->tm_mday + 10)) {
	    if (--alert_time.tm_mon < 0) {
		alert_time.tm_mon = 11;
		alert_time.tm_year--;
	    }
	}	
	alert_time.tm_min = minute;
	alert_time.tm_hour = hour;
	if (tolower(tz[0]) == 'z') {
	    alert_time.tm_hour -= zone/3600;
	    zone %= 3600;
	    if (zone) alert_time.tm_min += zone/60;
	    if (alert_time.tm_min > 60) {
		alert_time.tm_hour++;
		alert_time.tm_min -= 60;
	    }
	    if (alert_time.tm_hour > 23) {
		alert_time.tm_hour -= 24;
		alert_time.tm_mday++;
		if (mktime(&alert_time) == -1) {
		    alert_time.tm_mday = 1;
		    alert_time.tm_mon++;
		    if (mktime(&alert_time) == -1) {
			alert_time.tm_mon = 0;
			alert_time.tm_year++;
		    }
		}
	    }
	    else if (alert_time.tm_hour < 0) {
		alert_time.tm_hour += 24;
		if (--alert_time.tm_mday <= 0) {
		    if (--alert_time.tm_mon < 0) {
			alert_time.tm_year--;
			alert_time.tm_mon = 11;
			alert_time.tm_mday = 31;
		    }
		    else if (alert_time.tm_mon == 3 || alert_time.tm_mon == 5 ||
			     alert_time.tm_mon == 8 || alert_time.tm_mon == 10)
		      alert_time.tm_mday = 30;
		    else if (alert_time.tm_mon == 1)
		      alert_time.tm_mday = (alert_time.tm_year%4 == 0) ? 29: 28;
        else
		      alert_time.tm_mday = 31;
     } 
	    }
	}
    }
    return(mktime(&alert_time));
}
